(function (h, g, l) {
    function A(d, e) {
        this.wrapper = "string" == typeof d ? g.querySelector(d) : d;
        this.scroller = this.wrapper.children[0];
        this.scrollerStyle = this.scroller.style;
        this.options = {
            resizeScrollbars: !0,
            mouseWheelSpeed: 20,
            snapThreshold: .334,
            startX: 0,
            startY: 0,
            scrollY: !0,
            directionLockThreshold: 5,
            momentum: !0,
            bounce: !0,
            bounceTime: 600,
            bounceEasing: "",
            preventDefault: !0,
            preventDefaultException: {tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT)$/},
            HWCompositing: !0,
            useTransition: !0,
            useTransform: !0
        };
        for (var f in e)this.options[f] =
            e[f];
        this.translateZ = this.options.HWCompositing && k.hasPerspective ? " translateZ(0)" : "";
        this.options.useTransition = k.hasTransition && this.options.useTransition;
        this.options.useTransform = k.hasTransform && this.options.useTransform;
        this.options.eventPassthrough = !0 === this.options.eventPassthrough ? "vertical" : this.options.eventPassthrough;
        this.options.preventDefault = !this.options.eventPassthrough && this.options.preventDefault;
        this.options.scrollY = "vertical" == this.options.eventPassthrough ? !1 : this.options.scrollY;
        this.options.scrollX = "horizontal" == this.options.eventPassthrough ? !1 : this.options.scrollX;
        this.options.freeScroll = this.options.freeScroll && !this.options.eventPassthrough;
        this.options.directionLockThreshold = this.options.eventPassthrough ? 0 : this.options.directionLockThreshold;
        this.options.bounceEasing = "string" == typeof this.options.bounceEasing ? k.ease[this.options.bounceEasing] || k.ease.circular : this.options.bounceEasing;
        this.options.resizePolling = void 0 === this.options.resizePolling ? 60 : this.options.resizePolling;
        !0 === this.options.tap && (this.options.tap = "tap");
        "scale" == this.options.shrinkScrollbars && (this.options.useTransition = !1);
        this.options.invertWheelDirection = this.options.invertWheelDirection ? -1 : 1;
        this.directionY = this.directionX = this.y = this.x = 0;
        this._events = {};
        this._init();
        this.refresh();
        this.scrollTo(this.options.startX, this.options.startY);
        this.enable()
    }

    function w(d, e, f) {
        var m = g.createElement("div"), h = g.createElement("div");
        !0 === f && (m.style.cssText = "position:absolute;z-index:9999", h.style.cssText = "-webkit-box-sizing:border-box;-moz-box-sizing:border-box;box-sizing:border-box;position:absolute;background:rgba(0,0,0,0.5);border:1px solid rgba(255,255,255,0.9);border-radius:3px");
        h.className = "iScrollIndicator";
        "h" == d ? (!0 === f && (m.style.cssText += ";height:7px;left:2px;right:2px;bottom:0", h.style.height = "100%"), m.className = "iScrollHorizontalScrollbar") : (!0 === f && (m.style.cssText += ";width:7px;bottom:2px;top:2px;right:1px", h.style.width = "100%"), m.className = "iScrollVerticalScrollbar");
        m.style.cssText += ";overflow:hidden";
        e || (m.style.pointerEvents = "none");
        m.appendChild(h);
        return m
    }

    function p(d, e) {
        this.wrapper = "string" == typeof e.el ? g.querySelector(e.el) : e.el;
        this.wrapperStyle = this.wrapper.style;
        this.indicator = this.wrapper.children[0];
        this.indicatorStyle = this.indicator.style;
        this.scroller = d;
        this.options = {
            listenX: !0,
            listenY: !0,
            interactive: !1,
            resize: !0,
            defaultScrollbars: !1,
            shrink: !1,
            fade: !1,
            speedRatioX: 0,
            speedRatioY: 0
        };
        for (var f in e)this.options[f] = e[f];
        this.sizeRatioY = this.sizeRatioX = 1;
        this.maxPosY = this.maxPosX = 0;
        this.options.interactive && (this.options.disableTouch || (k.addEvent(this.indicator, "touchstart", this), k.addEvent(h, "touchend", this)), this.options.disablePointer || (k.addEvent(this.indicator,
            k.prefixPointerEvent("pointerdown"), this), k.addEvent(h, k.prefixPointerEvent("pointerup"), this)), this.options.disableMouse || (k.addEvent(this.indicator, "mousedown", this), k.addEvent(h, "mouseup", this)));
        this.options.fade && (this.wrapperStyle[k.style.transform] = this.scroller.translateZ, this.wrapperStyle[k.style.transitionDuration] = k.isBadAndroid ? "0.001s" : "0ms", this.wrapperStyle.opacity = "0")
    }

    var q = h.requestAnimationFrame || h.webkitRequestAnimationFrame || h.mozRequestAnimationFrame || h.oRequestAnimationFrame ||
        h.msRequestAnimationFrame || function (d) {
            h.setTimeout(d, 1E3 / 60)
        }, k = function () {
        function d(d) {
            return !1 === m ? !1 : "" === m ? d : m + d.charAt(0).toUpperCase() + d.substr(1)
        }

        var e = {}, f = g.createElement("div").style, m = function () {
            for (var d = ["t", "webkitT", "MozT", "msT", "OT"], e, m = 0, h = d.length; m < h; m++)if (e = d[m] + "ransform", e in f)return d[m].substr(0, d[m].length - 1);
            return !1
        }();
        e.getTime = Date.now || function () {
                return (new Date).getTime()
            };
        e.extend = function (d, e) {
            for (var f in e)d[f] = e[f]
        };
        e.addEvent = function (d, e, f, m) {
            d.addEventListener(e,
                f, !!m)
        };
        e.removeEvent = function (d, e, f, m) {
            d.removeEventListener(e, f, !!m)
        };
        e.prefixPointerEvent = function (d) {
            return h.MSPointerEvent ? "MSPointer" + d.charAt(9).toUpperCase() + d.substr(10) : d
        };
        e.momentum = function (d, e, f, m, h, k) {
            e = d - e;
            f = l.abs(e) / f;
            var g;
            k = void 0 === k ? 6E-4 : k;
            g = d + f * f / (2 * k) * (0 > e ? -1 : 1);
            k = f / k;
            g < m ? (g = h ? m - h / 2.5 * (f / 8) : m, e = l.abs(g - d), k = e / f) : 0 < g && (g = h ? h / 2.5 * (f / 8) : 0, e = l.abs(d) + g, k = e / f);
            return {destination: l.round(g), duration: k}
        };
        var k = d("transform");
        e.extend(e, {
            hasTransform: !1 !== k,
            hasPerspective: d("perspective") in
            f,
            hasTouch: "ontouchstart" in h,
            hasPointer: h.PointerEvent || h.MSPointerEvent,
            hasTransition: d("transition") in f
        });
        e.isBadAndroid = /Android /.test(h.navigator.appVersion) && !/Chrome\/\d/.test(h.navigator.appVersion);
        e.extend(e.style = {}, {
            transform: k,
            transitionTimingFunction: d("transitionTimingFunction"),
            transitionDuration: d("transitionDuration"),
            transitionDelay: d("transitionDelay"),
            transformOrigin: d("transformOrigin")
        });
        e.hasClass = function (d, e) {
            return (new RegExp("(^|\\s)" + e + "(\\s|$)")).test(d.className)
        };
        e.addClass = function (d, f) {
            if (!e.hasClass(d, f)) {
                var m = d.className.split(" ");
                m.push(f);
                d.className = m.join(" ")
            }
        };
        e.removeClass = function (d, f) {
            e.hasClass(d, f) && (d.className = d.className.replace(new RegExp("(^|\\s)" + f + "(\\s|$)", "g"), " "))
        };
        e.offset = function (d) {
            for (var e = -d.offsetLeft, f = -d.offsetTop; d = d.offsetParent;)e -= d.offsetLeft, f -= d.offsetTop;
            return {left: e, top: f}
        };
        e.preventDefaultException = function (d, e) {
            for (var f in e)if (e[f].test(d[f]))return !0;
            return !1
        };
        e.extend(e.eventType = {}, {
            touchstart: 1,
            touchmove: 1,
            touchend: 1,
            mousedown: 2,
            mousemove: 2,
            mouseup: 2,
            pointerdown: 3,
            pointermove: 3,
            pointerup: 3,
            MSPointerDown: 3,
            MSPointerMove: 3,
            MSPointerUp: 3
        });
        e.extend(e.ease = {}, {
            quadratic: {
                style: "cubic-bezier(0.25, 0.46, 0.45, 0.94)", fn: function (d) {
                    return d * (2 - d)
                }
            }, circular: {
                style: "cubic-bezier(0.1, 0.57, 0.1, 1)", fn: function (d) {
                    return l.sqrt(1 - --d * d)
                }
            }, back: {
                style: "cubic-bezier(0.175, 0.885, 0.32, 1.275)", fn: function (d) {
                    return --d * d * (5 * d + 4) + 1
                }
            }, bounce: {
                style: "", fn: function (d) {
                    return (d /= 1) < 1 / 2.75 ? 7.5625 * d * d : d < 2 / 2.75 ? 7.5625 *
                    (d -= 1.5 / 2.75) * d + .75 : d < 2.5 / 2.75 ? 7.5625 * (d -= 2.25 / 2.75) * d + .9375 : 7.5625 * (d -= 2.625 / 2.75) * d + .984375
                }
            }, elastic: {
                style: "", fn: function (d) {
                    return 0 === d ? 0 : 1 == d ? 1 : .4 * l.pow(2, -10 * d) * l.sin(2 * (d - .055) * l.PI / .22) + 1
                }
            }
        });
        e.tap = function (d, e) {
            var f = g.createEvent("Event");
            f.initEvent(e, !0, !0);
            f.pageX = d.pageX;
            f.pageY = d.pageY;
            d.target.dispatchEvent(f)
        };
        e.click = function (d) {
            var e = d.target, f;
            /(SELECT|INPUT|TEXTAREA)/i.test(e.tagName) || (f = g.createEvent("MouseEvents"), f.initMouseEvent("click", !0, !0, d.view, 1, e.screenX, e.screenY,
                e.clientX, e.clientY, d.ctrlKey, d.altKey, d.shiftKey, d.metaKey, 0, null), f._constructed = !0, e.dispatchEvent(f))
        };
        return e
    }();
    A.prototype = {
        version: "5.1.3", _init: function () {
            this._initEvents();
            (this.options.scrollbars || this.options.indicators) && this._initIndicators();
            this.options.mouseWheel && this._initWheel();
            this.options.snap && this._initSnap();
            this.options.keyBindings && this._initKeys()
        }, destroy: function () {
            this._initEvents(!0);
            this._execEvent("destroy")
        }, _transitionEnd: function (d) {
            d.target == this.scroller &&
            this.isInTransition && (this._transitionTime(), this.resetPosition(this.options.bounceTime) || (this.isInTransition = !1, this._execEvent("scrollEnd")))
        }, _start: function (d) {
            if (!(1 != k.eventType[d.type] && 0 !== d.button || !this.enabled || this.initiated && k.eventType[d.type] !== this.initiated)) {
                !this.options.preventDefault || k.isBadAndroid || k.preventDefaultException(d.target, this.options.preventDefaultException) || d.preventDefault();
                var e = d.touches ? d.touches[0] : d;
                this.initiated = k.eventType[d.type];
                this.moved = !1;
                this.directionLocked =
                    this.directionY = this.directionX = this.distY = this.distX = 0;
                this._transitionTime();
                this.startTime = k.getTime();
                this.options.useTransition && this.isInTransition ? (this.isInTransition = !1, d = this.getComputedPosition(), this._translate(l.round(d.x), l.round(d.y)), this._execEvent("scrollEnd")) : !this.options.useTransition && this.isAnimating && (this.isAnimating = !1, this._execEvent("scrollEnd"));
                this.startX = this.x;
                this.startY = this.y;
                this.absStartX = this.x;
                this.absStartY = this.y;
                this.pointX = e.pageX;
                this.pointY = e.pageY;
                this._execEvent("beforeScrollStart")
            }
        },
        _move: function (d) {
            if (this.enabled && k.eventType[d.type] === this.initiated) {
                this.options.preventDefault && d.preventDefault();
                var e = d.touches ? d.touches[0] : d, f = e.pageX - this.pointX, m = e.pageY - this.pointY, h = k.getTime(), g;
                this.pointX = e.pageX;
                this.pointY = e.pageY;
                this.distX += f;
                this.distY += m;
                e = l.abs(this.distX);
                g = l.abs(this.distY);
                if (!(300 < h - this.endTime && 10 > e && 10 > g)) {
                    this.directionLocked || this.options.freeScroll || (this.directionLocked = e > g + this.options.directionLockThreshold ? "h" : g >= e + this.options.directionLockThreshold ?
                        "v" : "n");
                    if ("h" == this.directionLocked) {
                        if ("vertical" == this.options.eventPassthrough)d.preventDefault(); else if ("horizontal" == this.options.eventPassthrough) {
                            this.initiated = !1;
                            return
                        }
                        m = 0
                    } else if ("v" == this.directionLocked) {
                        if ("horizontal" == this.options.eventPassthrough)d.preventDefault(); else if ("vertical" == this.options.eventPassthrough) {
                            this.initiated = !1;
                            return
                        }
                        f = 0
                    }
                    f = this.hasHorizontalScroll ? f : 0;
                    m = this.hasVerticalScroll ? m : 0;
                    d = this.x + f;
                    e = this.y + m;
                    if (0 < d || d < this.maxScrollX)d = this.options.bounce ? this.x +
                    f / 3 : 0 < d ? 0 : this.maxScrollX;
                    if (0 < e || e < this.maxScrollY)e = this.options.bounce ? this.y + m / 3 : 0 < e ? 0 : this.maxScrollY;
                    this.directionX = 0 < f ? -1 : 0 > f ? 1 : 0;
                    this.directionY = 0 < m ? -1 : 0 > m ? 1 : 0;
                    this.moved || this._execEvent("scrollStart");
                    this.moved = !0;
                    this._translate(d, e);
                    300 < h - this.startTime && (this.startTime = h, this.startX = this.x, this.startY = this.y)
                }
            }
        }, _end: function (d) {
            if (this.enabled && k.eventType[d.type] === this.initiated) {
                this.options.preventDefault && !k.preventDefaultException(d.target, this.options.preventDefaultException) &&
                d.preventDefault();
                var e, f;
                f = k.getTime() - this.startTime;
                var m = l.round(this.x), h = l.round(this.y), g = l.abs(m - this.startX), q = l.abs(h - this.startY);
                e = 0;
                var y = "";
                this.initiated = this.isInTransition = 0;
                this.endTime = k.getTime();
                if (!this.resetPosition(this.options.bounceTime))if (this.scrollTo(m, h), this.moved)if (this._events.flick && 200 > f && 100 > g && 100 > q)this._execEvent("flick"); else if (this.options.momentum && 300 > f && (e = this.hasHorizontalScroll ? k.momentum(this.x, this.startX, f, this.maxScrollX, this.options.bounce ? this.wrapperWidth :
                        0, this.options.deceleration) : {
                        destination: m,
                        duration: 0
                    }, f = this.hasVerticalScroll ? k.momentum(this.y, this.startY, f, this.maxScrollY, this.options.bounce ? this.wrapperHeight : 0, this.options.deceleration) : {
                        destination: h,
                        duration: 0
                    }, m = e.destination, h = f.destination, e = l.max(e.duration, f.duration), this.isInTransition = 1), this.options.snap && (this.currentPage = y = this._nearestSnap(m, h), e = this.options.snapSpeed || l.max(l.max(l.min(l.abs(m - y.x), 1E3), l.min(l.abs(h - y.y), 1E3)), 300), m = y.x, h = y.y, this.directionY = this.directionX =
                        0, y = this.options.bounceEasing), m != this.x || h != this.y) {
                    if (0 < m || m < this.maxScrollX || 0 < h || h < this.maxScrollY)y = k.ease.quadratic;
                    this.scrollTo(m, h, e, y)
                } else this._execEvent("scrollEnd"); else this.options.tap && k.tap(d, this.options.tap), this.options.click && k.click(d), this._execEvent("scrollCancel")
            }
        }, _resize: function () {
            var d = this;
            clearTimeout(this.resizeTimeout);
            this.resizeTimeout = setTimeout(function () {
                d.refresh()
            }, this.options.resizePolling)
        }, resetPosition: function (d) {
            var e = this.x, f = this.y;
            !this.hasHorizontalScroll ||
            0 < this.x ? e = 0 : this.x < this.maxScrollX && (e = this.maxScrollX);
            !this.hasVerticalScroll || 0 < this.y ? f = 0 : this.y < this.maxScrollY && (f = this.maxScrollY);
            if (e == this.x && f == this.y)return !1;
            this.scrollTo(e, f, d || 0, this.options.bounceEasing);
            return !0
        }, disable: function () {
            this.enabled = !1
        }, enable: function () {
            this.enabled = !0
        }, refresh: function () {
            this.wrapperWidth = this.wrapper.clientWidth;
            this.wrapperHeight = this.wrapper.clientHeight;
            this.scrollerWidth = this.scroller.offsetWidth;
            this.scrollerHeight = this.scroller.offsetHeight;
            this.maxScrollX = this.wrapperWidth - this.scrollerWidth;
            this.maxScrollY = this.wrapperHeight - this.scrollerHeight;
            this.hasHorizontalScroll = this.options.scrollX && 0 > this.maxScrollX;
            this.hasVerticalScroll = this.options.scrollY && 0 > this.maxScrollY;
            this.hasHorizontalScroll || (this.maxScrollX = 0, this.scrollerWidth = this.wrapperWidth);
            this.hasVerticalScroll || (this.maxScrollY = 0, this.scrollerHeight = this.wrapperHeight);
            this.directionY = this.directionX = this.endTime = 0;
            this.wrapperOffset = k.offset(this.wrapper);
            this._execEvent("refresh");
            this.resetPosition()
        }, on: function (d, e) {
            this._events[d] || (this._events[d] = []);
            this._events[d].push(e)
        }, off: function (d, e) {
            if (this._events[d]) {
                var f = this._events[d].indexOf(e);
                -1 < f && this._events[d].splice(f, 1)
            }
        }, _execEvent: function (d) {
            if (this._events[d]) {
                var e = 0, f = this._events[d].length;
                if (f)for (; e < f; e++)this._events[d][e].apply(this, [].slice.call(arguments, 1))
            }
        }, scrollBy: function (d, e, f, m) {
            d = this.x + d;
            e = this.y + e;
            this.scrollTo(d, e, f || 0, m)
        }, scrollTo: function (d, e, f, m) {
            m = m || k.ease.circular;
            this.isInTransition =
                this.options.useTransition && 0 < f;
            !f || this.options.useTransition && m.style ? (this._transitionTimingFunction(m.style), this._transitionTime(f), this._translate(d, e)) : this._animate(d, e, f, m.fn)
        }, scrollToElement: function (d, e, f, m, h) {
            if (d = d.nodeType ? d : this.scroller.querySelector(d)) {
                var g = k.offset(d);
                g.left -= this.wrapperOffset.left;
                g.top -= this.wrapperOffset.top;
                !0 === f && (f = l.round(d.offsetWidth / 2 - this.wrapper.offsetWidth / 2));
                !0 === m && (m = l.round(d.offsetHeight / 2 - this.wrapper.offsetHeight / 2));
                g.left -= f || 0;
                g.top -=
                    m || 0;
                g.left = 0 < g.left ? 0 : g.left < this.maxScrollX ? this.maxScrollX : g.left;
                g.top = 0 < g.top ? 0 : g.top < this.maxScrollY ? this.maxScrollY : g.top;
                e = void 0 === e || null === e || "auto" === e ? l.max(l.abs(this.x - g.left), l.abs(this.y - g.top)) : e;
                this.scrollTo(g.left, g.top, e, h)
            }
        }, _transitionTime: function (d) {
            d = d || 0;
            this.scrollerStyle[k.style.transitionDuration] = d + "ms";
            !d && k.isBadAndroid && (this.scrollerStyle[k.style.transitionDuration] = "0.001s");
            if (this.indicators)for (var e = this.indicators.length; e--;)this.indicators[e].transitionTime(d)
        },
        _transitionTimingFunction: function (d) {
            this.scrollerStyle[k.style.transitionTimingFunction] = d;
            if (this.indicators)for (var e = this.indicators.length; e--;)this.indicators[e].transitionTimingFunction(d)
        }, _translate: function (d, e) {
            this.options.useTransform ? this.scrollerStyle[k.style.transform] = "translate(" + d + "px," + e + "px)" + this.translateZ : (d = l.round(d), e = l.round(e), this.scrollerStyle.left = d + "px", this.scrollerStyle.top = e + "px");
            this.x = d;
            this.y = e;
            if (this.indicators)for (var f = this.indicators.length; f--;)this.indicators[f].updatePosition()
        },
        _initEvents: function (d) {
            d = d ? k.removeEvent : k.addEvent;
            var e = this.options.bindToWrapper ? this.wrapper : h;
            d(h, "orientationchange", this);
            d(h, "resize", this);
            this.options.click && d(this.wrapper, "click", this, !0);
            this.options.disableMouse || (d(this.wrapper, "mousedown", this), d(e, "mousemove", this), d(e, "mousecancel", this), d(e, "mouseup", this));
            k.hasPointer && !this.options.disablePointer && (d(this.wrapper, k.prefixPointerEvent("pointerdown"), this), d(e, k.prefixPointerEvent("pointermove"), this), d(e, k.prefixPointerEvent("pointercancel"),
                this), d(e, k.prefixPointerEvent("pointerup"), this));
            k.hasTouch && !this.options.disableTouch && (d(this.wrapper, "touchstart", this), d(e, "touchmove", this), d(e, "touchcancel", this), d(e, "touchend", this));
            d(this.scroller, "transitionend", this);
            d(this.scroller, "webkitTransitionEnd", this);
            d(this.scroller, "oTransitionEnd", this);
            d(this.scroller, "MSTransitionEnd", this)
        }, getComputedPosition: function () {
            var d = h.getComputedStyle(this.scroller, null), e;
            this.options.useTransform ? (d = d[k.style.transform].split(")")[0].split(", "),
                e = +(d[12] || d[4]), d = +(d[13] || d[5])) : (e = +d.left.replace(/[^-\d.]/g, ""), d = +d.top.replace(/[^-\d.]/g, ""));
            return {x: e, y: d}
        }, _initIndicators: function () {
            function d(d) {
                for (var e = k.indicators.length; e--;)d.call(k.indicators[e])
            }

            var e = this.options.interactiveScrollbars, f = "string" != typeof this.options.scrollbars, h = [], g, k = this;
            this.indicators = [];
            this.options.scrollbars && (this.options.scrollY && (g = {
                el: w("v", e, this.options.scrollbars),
                interactive: e,
                defaultScrollbars: !0,
                customStyle: f,
                resize: this.options.resizeScrollbars,
                shrink: this.options.shrinkScrollbars,
                fade: this.options.fadeScrollbars,
                listenX: !1
            }, this.wrapper.appendChild(g.el), h.push(g)), this.options.scrollX && (g = {
                el: w("h", e, this.options.scrollbars),
                interactive: e,
                defaultScrollbars: !0,
                customStyle: f,
                resize: this.options.resizeScrollbars,
                shrink: this.options.shrinkScrollbars,
                fade: this.options.fadeScrollbars,
                listenY: !1
            }, this.wrapper.appendChild(g.el), h.push(g)));
            this.options.indicators && (h = h.concat(this.options.indicators));
            for (e = h.length; e--;)this.indicators.push(new p(this,
                h[e]));
            this.options.fadeScrollbars && (this.on("scrollEnd", function () {
                d(function () {
                    this.fade()
                })
            }), this.on("scrollCancel", function () {
                d(function () {
                    this.fade()
                })
            }), this.on("scrollStart", function () {
                d(function () {
                    this.fade(1)
                })
            }), this.on("beforeScrollStart", function () {
                d(function () {
                    this.fade(1, !0)
                })
            }));
            this.on("refresh", function () {
                d(function () {
                    this.refresh()
                })
            });
            this.on("destroy", function () {
                d(function () {
                    this.destroy()
                });
                delete this.indicators
            })
        }, _initWheel: function () {
            k.addEvent(this.wrapper, "wheel", this);
            k.addEvent(this.wrapper, "mousewheel", this);
            k.addEvent(this.wrapper, "DOMMouseScroll", this);
            this.on("destroy", function () {
                k.removeEvent(this.wrapper, "wheel", this);
                k.removeEvent(this.wrapper, "mousewheel", this);
                k.removeEvent(this.wrapper, "DOMMouseScroll", this)
            })
        }, _wheel: function (d) {
            if (this.enabled) {
                d.preventDefault();
                d.stopPropagation();
                var e, f, h, g = this;
                void 0 === this.wheelTimeout && g._execEvent("scrollStart");
                clearTimeout(this.wheelTimeout);
                this.wheelTimeout = setTimeout(function () {
                    g._execEvent("scrollEnd");
                    g.wheelTimeout = void 0
                }, 400);
                if ("deltaX" in d)1 === d.deltaMode ? (e = -d.deltaX * this.options.mouseWheelSpeed, d = -d.deltaY * this.options.mouseWheelSpeed) : (e = -d.deltaX, d = -d.deltaY); else if ("wheelDeltaX" in d)e = d.wheelDeltaX / 120 * this.options.mouseWheelSpeed, d = d.wheelDeltaY / 120 * this.options.mouseWheelSpeed; else if ("wheelDelta" in d)e = d = d.wheelDelta / 120 * this.options.mouseWheelSpeed; else if ("detail" in d)e = d = -d.detail / 3 * this.options.mouseWheelSpeed; else return;
                e *= this.options.invertWheelDirection;
                d *= this.options.invertWheelDirection;
                this.hasVerticalScroll || (e = d, d = 0);
                this.options.snap ? (f = this.currentPage.pageX, h = this.currentPage.pageY, 0 < e ? f-- : 0 > e && f++, 0 < d ? h-- : 0 > d && h++, this.goToPage(f, h)) : (f = this.x + l.round(this.hasHorizontalScroll ? e : 0), h = this.y + l.round(this.hasVerticalScroll ? d : 0), 0 < f ? f = 0 : f < this.maxScrollX && (f = this.maxScrollX), 0 < h ? h = 0 : h < this.maxScrollY && (h = this.maxScrollY), this.scrollTo(f, h, 0))
            }
        }, _initSnap: function () {
            this.currentPage = {};
            "string" == typeof this.options.snap && (this.options.snap = this.scroller.querySelectorAll(this.options.snap));
            this.on("refresh", function () {
                var d = 0, e, f = 0, h, g, k, q = 0, p;
                h = this.options.snapStepX || this.wrapperWidth;
                var u = this.options.snapStepY || this.wrapperHeight;
                this.pages = [];
                if (this.wrapperWidth && this.wrapperHeight && this.scrollerWidth && this.scrollerHeight) {
                    if (!0 === this.options.snap)for (g = l.round(h / 2), k = l.round(u / 2); q > -this.scrollerWidth;) {
                        this.pages[d] = [];
                        for (p = e = 0; p > -this.scrollerHeight;)this.pages[d][e] = {
                            x: l.max(q, this.maxScrollX),
                            y: l.max(p, this.maxScrollY),
                            width: h,
                            height: u,
                            cx: q - g,
                            cy: p - k
                        }, p -= u, e++;
                        q -= h;
                        d++
                    } else for (u =
                                    this.options.snap, e = u.length, h = -1; d < e; d++) {
                        if (0 === d || u[d].offsetLeft <= u[d - 1].offsetLeft)f = 0, h++;
                        this.pages[f] || (this.pages[f] = []);
                        q = l.max(-u[d].offsetLeft, this.maxScrollX);
                        p = l.max(-u[d].offsetTop, this.maxScrollY);
                        g = q - l.round(u[d].offsetWidth / 2);
                        k = p - l.round(u[d].offsetHeight / 2);
                        this.pages[f][h] = {
                            x: q,
                            y: p,
                            width: u[d].offsetWidth,
                            height: u[d].offsetHeight,
                            cx: g,
                            cy: k
                        };
                        q > this.maxScrollX && f++
                    }
                    this.goToPage(this.currentPage.pageX || 0, this.currentPage.pageY || 0, 0);
                    0 === this.options.snapThreshold % 1 ? this.snapThresholdY =
                        this.snapThresholdX = this.options.snapThreshold : (this.snapThresholdX = l.round(this.pages[this.currentPage.pageX][this.currentPage.pageY].width * this.options.snapThreshold), this.snapThresholdY = l.round(this.pages[this.currentPage.pageX][this.currentPage.pageY].height * this.options.snapThreshold))
                }
            });
            this.on("flick", function () {
                var d = this.options.snapSpeed || l.max(l.max(l.min(l.abs(this.x - this.startX), 1E3), l.min(l.abs(this.y - this.startY), 1E3)), 300);
                this.goToPage(this.currentPage.pageX + this.directionX, this.currentPage.pageY +
                    this.directionY, d)
            })
        }, _nearestSnap: function (d, e) {
            if (!this.pages.length)return {x: 0, y: 0, pageX: 0, pageY: 0};
            var f = 0, h = this.pages.length, g = 0;
            if (l.abs(d - this.absStartX) < this.snapThresholdX && l.abs(e - this.absStartY) < this.snapThresholdY)return this.currentPage;
            0 < d ? d = 0 : d < this.maxScrollX && (d = this.maxScrollX);
            0 < e ? e = 0 : e < this.maxScrollY && (e = this.maxScrollY);
            for (; f < h; f++)if (d >= this.pages[f][0].cx) {
                d = this.pages[f][0].x;
                break
            }
            for (h = this.pages[f].length; g < h; g++)if (e >= this.pages[0][g].cy) {
                e = this.pages[0][g].y;
                break
            }
            f ==
            this.currentPage.pageX && (f += this.directionX, 0 > f ? f = 0 : f >= this.pages.length && (f = this.pages.length - 1), d = this.pages[f][0].x);
            g == this.currentPage.pageY && (g += this.directionY, 0 > g ? g = 0 : g >= this.pages[0].length && (g = this.pages[0].length - 1), e = this.pages[0][g].y);
            return {x: d, y: e, pageX: f, pageY: g}
        }, goToPage: function (d, e, f, h) {
            h = h || this.options.bounceEasing;
            d >= this.pages.length ? d = this.pages.length - 1 : 0 > d && (d = 0);
            e >= this.pages[d].length ? e = this.pages[d].length - 1 : 0 > e && (e = 0);
            var g = this.pages[d][e].x, k = this.pages[d][e].y;
            f =
                void 0 === f ? this.options.snapSpeed || l.max(l.max(l.min(l.abs(g - this.x), 1E3), l.min(l.abs(k - this.y), 1E3)), 300) : f;
            this.currentPage = {x: g, y: k, pageX: d, pageY: e};
            this.scrollTo(g, k, f, h)
        }, next: function (d, e) {
            var f = this.currentPage.pageX, h = this.currentPage.pageY;
            f++;
            f >= this.pages.length && this.hasVerticalScroll && (f = 0, h++);
            this.goToPage(f, h, d, e)
        }, prev: function (d, e) {
            var f = this.currentPage.pageX, h = this.currentPage.pageY;
            f--;
            0 > f && this.hasVerticalScroll && (f = 0, h--);
            this.goToPage(f, h, d, e)
        }, _initKeys: function (d) {
            d = {
                pageUp: 33,
                pageDown: 34, end: 35, home: 36, left: 37, up: 38, right: 39, down: 40
            };
            var e;
            if ("object" == typeof this.options.keyBindings)for (e in this.options.keyBindings)"string" == typeof this.options.keyBindings[e] && (this.options.keyBindings[e] = this.options.keyBindings[e].toUpperCase().charCodeAt(0)); else this.options.keyBindings = {};
            for (e in d)this.options.keyBindings[e] = this.options.keyBindings[e] || d[e];
            k.addEvent(h, "keydown", this);
            this.on("destroy", function () {
                k.removeEvent(h, "keydown", this)
            })
        }, _key: function (d) {
            if (this.enabled) {
                var e =
                    this.options.snap, f = e ? this.currentPage.pageX : this.x, h = e ? this.currentPage.pageY : this.y, g = k.getTime(), q = this.keyTime || 0, p;
                this.options.useTransition && this.isInTransition && (p = this.getComputedPosition(), this._translate(l.round(p.x), l.round(p.y)), this.isInTransition = !1);
                this.keyAcceleration = 200 > g - q ? l.min(this.keyAcceleration + .25, 50) : 0;
                switch (d.keyCode) {
                    case this.options.keyBindings.pageUp:
                        this.hasHorizontalScroll && !this.hasVerticalScroll ? f += e ? 1 : this.wrapperWidth : h += e ? 1 : this.wrapperHeight;
                        break;
                    case this.options.keyBindings.pageDown:
                        this.hasHorizontalScroll && !this.hasVerticalScroll ? f -= e ? 1 : this.wrapperWidth : h -= e ? 1 : this.wrapperHeight;
                        break;
                    case this.options.keyBindings.end:
                        f = e ? this.pages.length - 1 : this.maxScrollX;
                        h = e ? this.pages[0].length - 1 : this.maxScrollY;
                        break;
                    case this.options.keyBindings.home:
                        h = f = 0;
                        break;
                    case this.options.keyBindings.left:
                        f += e ? -1 : 5 + this.keyAcceleration >> 0;
                        break;
                    case this.options.keyBindings.up:
                        h += e ? 1 : 5 + this.keyAcceleration >> 0;
                        break;
                    case this.options.keyBindings.right:
                        f -= e ? -1 : 5 + this.keyAcceleration >> 0;
                        break;
                    case this.options.keyBindings.down:
                        h -=
                            e ? 1 : 5 + this.keyAcceleration >> 0;
                        break;
                    default:
                        return
                }
                e ? this.goToPage(f, h) : (0 < f ? this.keyAcceleration = f = 0 : f < this.maxScrollX && (f = this.maxScrollX, this.keyAcceleration = 0), 0 < h ? this.keyAcceleration = h = 0 : h < this.maxScrollY && (h = this.maxScrollY, this.keyAcceleration = 0), this.scrollTo(f, h, 0), this.keyTime = g)
            }
        }, _animate: function (d, e, h, g) {
            function l() {
                var D = k.getTime(), w;
                D >= z ? (p.isAnimating = !1, p._translate(d, e), p.resetPosition(p.options.bounceTime) || p._execEvent("scrollEnd")) : (D = (D - u) / h, w = g(D), D = (d - A) * w + A, w = (e - y) * w +
                    y, p._translate(D, w), p.isAnimating && q(l))
            }

            var p = this, A = this.x, y = this.y, u = k.getTime(), z = u + h;
            this.isAnimating = !0;
            l()
        }, handleEvent: function (d) {
            switch (d.type) {
                case "touchstart":
                case "pointerdown":
                case "MSPointerDown":
                case "mousedown":
                    this._start(d);
                    break;
                case "touchmove":
                case "pointermove":
                case "MSPointerMove":
                case "mousemove":
                    this._move(d);
                    break;
                case "touchend":
                case "pointerup":
                case "MSPointerUp":
                case "mouseup":
                case "touchcancel":
                case "pointercancel":
                case "MSPointerCancel":
                case "mousecancel":
                    this._end(d);
                    break;
                case "orientationchange":
                case "resize":
                    this._resize();
                    break;
                case "transitionend":
                case "webkitTransitionEnd":
                case "oTransitionEnd":
                case "MSTransitionEnd":
                    this._transitionEnd(d);
                    break;
                case "wheel":
                case "DOMMouseScroll":
                case "mousewheel":
                    this._wheel(d);
                    break;
                case "keydown":
                    this._key(d);
                    break;
                case "click":
                    d._constructed || (d.preventDefault(), d.stopPropagation())
            }
        }
    };
    p.prototype = {
        handleEvent: function (d) {
            switch (d.type) {
                case "touchstart":
                case "pointerdown":
                case "MSPointerDown":
                case "mousedown":
                    this._start(d);
                    break;
                case "touchmove":
                case "pointermove":
                case "MSPointerMove":
                case "mousemove":
                    this._move(d);
                    break;
                case "touchend":
                case "pointerup":
                case "MSPointerUp":
                case "mouseup":
                case "touchcancel":
                case "pointercancel":
                case "MSPointerCancel":
                case "mousecancel":
                    this._end(d)
            }
        }, destroy: function () {
            this.options.interactive && (k.removeEvent(this.indicator, "touchstart", this), k.removeEvent(this.indicator, k.prefixPointerEvent("pointerdown"), this), k.removeEvent(this.indicator, "mousedown", this), k.removeEvent(h, "touchmove",
                this), k.removeEvent(h, k.prefixPointerEvent("pointermove"), this), k.removeEvent(h, "mousemove", this), k.removeEvent(h, "touchend", this), k.removeEvent(h, k.prefixPointerEvent("pointerup"), this), k.removeEvent(h, "mouseup", this));
            this.options.defaultScrollbars && this.wrapper.parentNode.removeChild(this.wrapper)
        }, _start: function (d) {
            var e = d.touches ? d.touches[0] : d;
            d.preventDefault();
            d.stopPropagation();
            this.transitionTime();
            this.initiated = !0;
            this.moved = !1;
            this.lastPointX = e.pageX;
            this.lastPointY = e.pageY;
            this.startTime =
                k.getTime();
            this.options.disableTouch || k.addEvent(h, "touchmove", this);
            this.options.disablePointer || k.addEvent(h, k.prefixPointerEvent("pointermove"), this);
            this.options.disableMouse || k.addEvent(h, "mousemove", this);
            this.scroller._execEvent("beforeScrollStart")
        }, _move: function (d) {
            var e = d.touches ? d.touches[0] : d, h, g;
            k.getTime();
            this.moved || this.scroller._execEvent("scrollStart");
            this.moved = !0;
            h = e.pageX - this.lastPointX;
            this.lastPointX = e.pageX;
            g = e.pageY - this.lastPointY;
            this.lastPointY = e.pageY;
            this._pos(this.x +
                h, this.y + g);
            d.preventDefault();
            d.stopPropagation()
        }, _end: function (d) {
            if (this.initiated) {
                this.initiated = !1;
                d.preventDefault();
                d.stopPropagation();
                k.removeEvent(h, "touchmove", this);
                k.removeEvent(h, k.prefixPointerEvent("pointermove"), this);
                k.removeEvent(h, "mousemove", this);
                if (this.scroller.options.snap) {
                    d = this.scroller._nearestSnap(this.scroller.x, this.scroller.y);
                    var e = this.options.snapSpeed || l.max(l.max(l.min(l.abs(this.scroller.x - d.x), 1E3), l.min(l.abs(this.scroller.y - d.y), 1E3)), 300);
                    if (this.scroller.x !=
                        d.x || this.scroller.y != d.y)this.scroller.directionX = 0, this.scroller.directionY = 0, this.scroller.currentPage = d, this.scroller.scrollTo(d.x, d.y, e, this.scroller.options.bounceEasing)
                }
                this.moved && this.scroller._execEvent("scrollEnd")
            }
        }, transitionTime: function (d) {
            d = d || 0;
            this.indicatorStyle[k.style.transitionDuration] = d + "ms";
            !d && k.isBadAndroid && (this.indicatorStyle[k.style.transitionDuration] = "0.001s")
        }, transitionTimingFunction: function (d) {
            this.indicatorStyle[k.style.transitionTimingFunction] = d
        }, refresh: function () {
            this.transitionTime();
            this.indicatorStyle.display = this.options.listenX && !this.options.listenY ? this.scroller.hasHorizontalScroll ? "block" : "none" : this.options.listenY && !this.options.listenX ? this.scroller.hasVerticalScroll ? "block" : "none" : this.scroller.hasHorizontalScroll || this.scroller.hasVerticalScroll ? "block" : "none";
            this.scroller.hasHorizontalScroll && this.scroller.hasVerticalScroll ? (k.addClass(this.wrapper, "iScrollBothScrollbars"), k.removeClass(this.wrapper, "iScrollLoneScrollbar"), this.options.defaultScrollbars && this.options.customStyle &&
            (this.options.listenX ? this.wrapper.style.right = "8px" : this.wrapper.style.bottom = "8px")) : (k.removeClass(this.wrapper, "iScrollBothScrollbars"), k.addClass(this.wrapper, "iScrollLoneScrollbar"), this.options.defaultScrollbars && this.options.customStyle && (this.options.listenX ? this.wrapper.style.right = "2px" : this.wrapper.style.bottom = "2px"));
            this.options.listenX && (this.wrapperWidth = this.wrapper.clientWidth, this.options.resize ? (this.indicatorWidth = l.max(l.round(this.wrapperWidth * this.wrapperWidth / (this.scroller.scrollerWidth ||
                this.wrapperWidth || 1)), 8), this.indicatorStyle.width = this.indicatorWidth + "px") : this.indicatorWidth = this.indicator.clientWidth, this.maxPosX = this.wrapperWidth - this.indicatorWidth, "clip" == this.options.shrink ? (this.minBoundaryX = -this.indicatorWidth + 8, this.maxBoundaryX = this.wrapperWidth - 8) : (this.minBoundaryX = 0, this.maxBoundaryX = this.maxPosX), this.sizeRatioX = this.options.speedRatioX || this.scroller.maxScrollX && this.maxPosX / this.scroller.maxScrollX);
            this.options.listenY && (this.wrapperHeight = this.wrapper.clientHeight,
                this.options.resize ? (this.indicatorHeight = l.max(l.round(this.wrapperHeight * this.wrapperHeight / (this.scroller.scrollerHeight || this.wrapperHeight || 1)), 8), this.indicatorStyle.height = this.indicatorHeight + "px") : this.indicatorHeight = this.indicator.clientHeight, this.maxPosY = this.wrapperHeight - this.indicatorHeight, "clip" == this.options.shrink ? (this.minBoundaryY = -this.indicatorHeight + 8, this.maxBoundaryY = this.wrapperHeight - 8) : (this.minBoundaryY = 0, this.maxBoundaryY = this.maxPosY), this.maxPosY = this.wrapperHeight -
                this.indicatorHeight, this.sizeRatioY = this.options.speedRatioY || this.scroller.maxScrollY && this.maxPosY / this.scroller.maxScrollY);
            this.updatePosition()
        }, updatePosition: function () {
            var d = this.options.listenX && l.round(this.sizeRatioX * this.scroller.x) || 0, e = this.options.listenY && l.round(this.sizeRatioY * this.scroller.y) || 0;
            this.options.ignoreBoundaries || (d < this.minBoundaryX ? ("scale" == this.options.shrink && (this.width = l.max(this.indicatorWidth + d, 8), this.indicatorStyle.width = this.width + "px"), d = this.minBoundaryX) :
                d > this.maxBoundaryX ? "scale" == this.options.shrink ? (this.width = l.max(this.indicatorWidth - (d - this.maxPosX), 8), this.indicatorStyle.width = this.width + "px", d = this.maxPosX + this.indicatorWidth - this.width) : d = this.maxBoundaryX : "scale" == this.options.shrink && this.width != this.indicatorWidth && (this.width = this.indicatorWidth, this.indicatorStyle.width = this.width + "px"), e < this.minBoundaryY ? ("scale" == this.options.shrink && (this.height = l.max(this.indicatorHeight + 3 * e, 8), this.indicatorStyle.height = this.height + "px"), e = this.minBoundaryY) :
                e > this.maxBoundaryY ? "scale" == this.options.shrink ? (this.height = l.max(this.indicatorHeight - 3 * (e - this.maxPosY), 8), this.indicatorStyle.height = this.height + "px", e = this.maxPosY + this.indicatorHeight - this.height) : e = this.maxBoundaryY : "scale" == this.options.shrink && this.height != this.indicatorHeight && (this.height = this.indicatorHeight, this.indicatorStyle.height = this.height + "px"));
            this.x = d;
            this.y = e;
            this.scroller.options.useTransform ? this.indicatorStyle[k.style.transform] = "translate(" + d + "px," + e + "px)" + this.scroller.translateZ :
                (this.indicatorStyle.left = d + "px", this.indicatorStyle.top = e + "px")
        }, _pos: function (d, e) {
            0 > d ? d = 0 : d > this.maxPosX && (d = this.maxPosX);
            0 > e ? e = 0 : e > this.maxPosY && (e = this.maxPosY);
            d = this.options.listenX ? l.round(d / this.sizeRatioX) : this.scroller.x;
            e = this.options.listenY ? l.round(e / this.sizeRatioY) : this.scroller.y;
            this.scroller.scrollTo(d, e)
        }, fade: function (d, e) {
            if (!e || this.visible) {
                clearTimeout(this.fadeTimeout);
                this.fadeTimeout = null;
                var h = d ? 250 : 500, g = d ? 0 : 300;
                this.wrapperStyle[k.style.transitionDuration] = h + "ms";
                this.fadeTimeout =
                    setTimeout(function (d) {
                        this.wrapperStyle.opacity = d;
                        this.visible = +d
                    }.bind(this, d ? "1" : "0"), g)
            }
        }
    };
    A.utils = k;
    "undefined" != typeof module && module.exports ? module.exports = A : h.IScroll = A
})(window, document, Math);
var scrollWrapper = function () {
    return function (h) {
        h && "object" === typeof h || (h = {});
        var g = h.top || 0, l = h.left || 0, A, w, p = h.initPlace, q = h.endPlace, k = h.orientation || 0, d = h.parametr, e = h.page, f = h.obj, m = h.touchObj, I = h.settings, ba = h.obj.parent().width(), N, y = h.animateFlag, u = h.barrelSector, z = h.offsetTop, D = h.rollToPos, ra = h.onSettingUpdate, ca = h.checkPosition, da = h.onClass || !1, ea = (l.min + l.max) / 2, J;
        l.min > l.max && (J = l.min, l.min = l.max, l.max = J, J = !0);
        return instance = {
            top: g,
            offset: {x: 0, y: 0},
            left: l,
            start: {x: 0, y: 0},
            initPlace: p,
            endPlace: q,
            parentHeight: 0,
            orientation: k || 0,
            parametr: d,
            page: e,
            obj: f,
            touchObj: m,
            parentWidth: f.parent().width(),
            touchStart: function (d) {
                d.preventDefault();
                N = !1;
                A = d.originalEvent.touches ? d.originalEvent.touches[0].pageX : d.pageX;
                w = d.originalEvent.touches ? d.originalEvent.touches[0].pageY : d.pageY
            },
            touchMove: function (h) {
                h.preventDefault();
                N = !0;
                if (k) {
                    var m = h.originalEvent.touches ? h.originalEvent.touches[0] : h;
                    h = A - m.pageX;
                    instance.offset.y = m = w - m.pageY;
                    currentX = parseInt((p.x - 100 * h / ba).toFixed(1));
                    currentY = parseInt((p.y -
                    m / 4).toFixed(1));
                    "h" == k && currentX <= l.max && currentX >= l.min ? (q.x = p.x - 100 * h / ba, $(f).css(d, q.x + "%"), 4 > instance.offset.x && (N = !1)) : "v" == k && currentY <= g.max && currentY >= g.min && (q.y = (p.y - m / 4).toFixed(1), $(f).css(d, q.y + "%"), "bets" == e && ca(q.y, f, !0))
                } else console.log("orientation is not define!")
            },
            touchEnd: function (h) {
                var m = null;
                h.preventDefault();
                if (k) {
                    if ("h" == k) {
                        index = $(f).parent().parent().index(".lineHolder");
                        if (N) {
                            if (q.x < l.min || q.x < ea)q.x = l.min, I[index] = J ? 1 : 0;
                            if (q.x > l.max || q.x >= ea)q.x = l.max, I[index] = J ? 0 :
                                1
                        } else q.x = 1 == I[index] && !J || 0 == I[index] && J ? l.min : l.max, I[index] = 1 == I[index] ? 0 : 1;
                        1 == I[index] ? $(f).css(d, q.x + "%").addClass(da) : $(f).css(d, q.x + "%").removeClass(da);
                        ra(index)
                    } else if (N && 2 < Math.abs(instance.offset.y))q.y < g.min && (q.y = g.min), q.y > g.max && (q.y = g.max), $(f).css(d, q.y + "px"); else if (!y)switch ($.each(u, function () {
                        if (null == m || Math.abs(this - w) < Math.abs(m - w))m = parseFloat(this)
                    }), u.indexOf(m)) {
                        case 0:
                        case 1:
                            0 < z.indexOf(p.y) && (D(z.indexOf(p.y), z.indexOf(p.y) - 1, f), q.y = p.y = z[z.indexOf(p.y) - 1]);
                            return;
                        case 5:
                        case 6:
                            z.indexOf(p.y) < z.length - 1 && (D(z.indexOf(p.y), z.indexOf(p.y) + 1, f), q.y = p.y = z[z.indexOf(p.y) + 1]);
                            return
                    }
                    "bets" == e && N && (ca(q.y, f, !1), $.each(z, function () {
                        if (null == m || Math.abs(this - q.y) < Math.abs(m - q.y))m = parseFloat(this)
                    }), q.y = m);
                    p.x = q.x;
                    p.y = q.y
                } else console.log("orientation is not define!")
            },
            setAminateFlag: function (d) {
                y = d
            }
        }
    }
}(), GslotWrapper = function () {
    var h;
    return function (g) {
        if (h)return h;
        g && "object" === typeof g || (g = {});
        var l = !!g.debug, A = {
                lines: "object",
                reils: "object",
                RT: "int",
                LT: "int",
                w: "float",
                h: "float",
                pdy: "float",
                pdx: "float",
                tiles: "object",
                gameName: "string",
                gameTitle: "string",
                isFreegameRestart: "boolean",
                scatterSymbol: "int",
                linesValues: "object",
                wildSymbol: "int",
                multiple: "object",
                denominationRule: "object",
                connectUrl: "string",
                spinnersCount: "int",
                BACKURL: "string",
                CASHURL: "string",
                winLineAnimation: "boolean",
                linesMarginX: "float",
                strokeWidth: "float",
                inertionDistance: "object",
                startVelocity: "object",
                outerSpeed: "object",
                startSpinsDelayFrames: "object",
                spinnerDumping: "object",
                returnVelocity: "object",
                returnSpeed: "object",
                stopSpinsDefault: "object",
                animate: "object",
                scrollWrapper: "function",
                IScroll: "function",
                paytableInsertSymbols: "object",
                borderRadius: "string",
                winLinesRepeats: "int",
                LANGUAGE: "string",
                SHOWPOPUP: "string",
                translateNow: "object",
                POPUPTIMEOUT: "int",
                POPUPTITLE: "string",
                POPUPBTN1TEXT: "string",
                POPUPREPEATS: "int",
                POPUPBTN1URL: "string",
                POPUPTEXT: "string",
                POPUPBTN2URL: "string",
                POPUPBTN2TEXT: "string",
                AUTHORIZED: "string",
                pointerLeft: "float",
                pointerRight: "float",
                betsOffsetTop: "float",
                shadowScreenOpacity: "float"
            },
            w = {
                RT: 350,
                LT: 700,
                pdy: -.1,
                pdx: 2.5,
                w: 18,
                h: 33.3,
                winLineAnimation: !1,
                linesMarginX: -3,
                connectUrl: "/mobile/novomatic/",
                spinnersCount: 5,
                spinnerLength: 3,
                strokeWidth: .3,
                startVelocity: [.9, .9, .9, .9, .9],
                startSpinsDelayFrames: [0, 0, 0, 0, 0],
                outerSpeed: [2, 2, 2, 2, 2],
                spinnerDumping: [.2, .2, .2, .2, .2],
                inertionDistance: [.1, .1, .1, .1, .1],
                returnSpeed: [5, 5, 5, 5, 5],
                returnVelocity: [-.1, -.1, -.1, -.1, -.1],
                stopSpinsDefault: [6, 11, 16, 21, 26],
                paytableInsertSymbols: [],
                isFreegameRestart: !1,
                borderRadius: "0",
                winLinesRepeats: !1,
                LANGUAGE: K,
                translateNow: [],
                SHOWPOPUP: sa,
                POPUPTIMEOUT: Ea,
                POPUPTITLE: Fa,
                POPUPTEXT: Ga,
                POPUPREPEATS: ta,
                POPUPBTN1URL: V,
                POPUPBTN1TEXT: fa,
                POPUPBTN2URL: W,
                POPUPBTN2TEXT: X,
                AUTHORIZED: Ha,
                shadowScreenOpacity: 0,
                pointerLeft: -5,
                pointerRight: 44.6,
                betsOffsetTop: 34.5,
                random: function (lenght) {
                  return  Math.round(Math.random() * lenght)
                },
                resultSpin: [
                    {"balance":998,"symbols":[[7,6,8],[6,5,7],[6,8,2],[7,5,8],[7,2,4]],"winnings":{"lines":[{"line":7,"symbols":[{"0":2,"1":2},{"0":3,"1":2},{"0":4,"1":1}],"winning":2},{"line":8,"symbols":[{"0":0,"1":1},{"0":1,"1":0},{"0":2,"1":0}],"winning":5}],"scatter":null,"total":7},"bonus_game":null}
                    ,{"balance":1009,"symbols":[[8,4,5],[7,5,7],[7,8,4],[6,8,4],[3,4,8]],"winnings":{"lines":[{"line":7,"symbols":[{"0":2,"1":2},{"0":3,"1":2},{"0":4,"1":1}],"winning":20}],"scatter":null,"total":20},"bonus_game":null}
                    ,{"balance":1005,"symbols":[[8,3,7],[4,7,8],[7,8,6],[3,7,5],[1,4,6]],"winnings":{"lines":[{"line":4,"symbols":[{"0":0,"1":2},{"0":1,"1":1},{"0":2,"1":0},{"0":3,"1":1}],"winning":5}],"scatter":null,"total":5},"bonus_game":null}
                    ,{"balance":996,"symbols":[[0,8,6],[1,7,8],[6,8,3],[3,7,5],[7,5,6]],"winnings":{"scatter":null,"total":0},"bonus_game":null}
                    ,{"balance":989,"symbols":[[4,8,2],[8,6,5],[1,7,8],[7,8,6],[8,5,7]],"winnings":{"lines":[{"line":3,"symbols":[{"0":2,"1":2},{"0":3,"1":1},{"0":4,"1":0}],"winning":2}],"scatter":null,"total":2},"bonus_game":null}
                    ,{"balance":982,"symbols":[[8,1,5],[5,7,6],[8,4,5],[0,8,7],[7,5,8]],"winnings":{"lines":[{"line":4,"symbols":[{"0":2,"1":0},{"0":3,"1":1},{"0":4,"1":2}],"winning":2}],"scatter":null,"total":2},"bonus_game":null}
                    ,{"balance":976,"symbols":[[6,2,5],[5,7,8],[7,2,5],[8,5,3],[7,0,8]],"winnings":{"lines":[{"line":0,"symbols":[{"0":0,"1":1},{"0":1,"1":1},{"0":2,"1":1}],"winning":3}],"scatter":null,"total":3},"bonus_game":null}
                    ,{"balance":967,"symbols":[[3,7,2],[8,5,4],[7,3,8],[5,0,8],[8,5,7]],"winnings":{"scatter":null,"total":0},"bonus_game":null}
                    ,{"balance":970,"symbols":[[4,6,8],[1,7,8],[7,8,2],[2,7,3],[7,4,8]],"winnings":{"lines":[{"line":1,"symbols":[{"0":2,"1":0},{"0":3,"1":0},{"0":4,"1":0}],"winning":3},{"line":2,"symbols":[{"0":0,"1":2},{"0":1,"1":2},{"0":2,"1":2}],"winning":2},{"line":3,"symbols":[{"0":1,"1":1},{"0":2,"1":2},{"0":3,"1":1},{"0":4,"1":0}],"winning":5},{"line":6,"symbols":[{"0":0,"1":2},{"0":1,"1":2},{"0":2,"1":1}],"winning":2}],"scatter":null,"total":12},"bonus_game":null}
                ],
                resultGetDouble: [
                    {"balance":970,"winnings":{"total":12},"step":1,"cards":[{"rank":7,"suit":"diamonds"}],"open_card":[{"rank":7,"suit":"diamonds"}]},
                    {"balance":959,"winnings":{"total":10},"step":1,"cards":[{"rank":9,"suit":"hearts"}],"open_card":[{"rank":9,"suit":"hearts"}]},
                    {"balance":969,"winnings":{"total":20},"step":2,"cards":[{"rank":5,"suit":"diamonds"}],"open_card":[{"rank":5,"suit":"diamonds"}]},
                    {"balance":989,"winnings":{"total":40},"step":3,"cards":[{"rank":6,"suit":"hearts"}],"open_card":[{"rank":6,"suit":"hearts"}]},
                    {"balance":1029,"winnings":{"total":80},"step":4,"cards":[{"rank":5,"suit":"diamonds"}],"open_card":[{"rank":5,"suit":"diamonds"}]}
                ],
                resultSetDouble: [
                    {"balance":958,"winnings":{"total":0},"step":1,"cards":[{"rank":3,"suit":"diamonds"},{"rank":12,"suit":"clubs"},{"rank":2,"suit":"clubs"},{"rank":4,"suit":"clubs"}],"open_card":[{"rank":7,"suit":"diamonds"}],"status":0}
                    ,{"balance":969,"winnings":{"total":20},"step":1,"cards":[{"rank":10,"suit":"diamonds"},{"rank":14,"suit":"clubs"},{"rank":12,"suit":"diamonds"},{"rank":3,"suit":"hearts"}],"open_card":[{"rank":9,"suit":"hearts"}],"status":1}
                    ,{"balance":989,"winnings":{"total":40},"step":2,"cards":[{"rank":14,"suit":"diamonds"},{"rank":6,"suit":"spades"},{"rank":10,"suit":"clubs"},{"rank":11,"suit":"hearts"}],"open_card":[{"rank":5,"suit":"diamonds"}],"status":1}
                    ,{"balance":1029,"winnings":{"total":80},"step":3,"cards":[{"rank":9,"suit":"spades"},{"rank":13,"suit":"diamonds"},{"rank":9,"suit":"clubs"},{"rank":2,"suit":"spades"}],"open_card":[{"rank":6,"suit":"hearts"}],"status":1}
                    ,{"balance":949,"winnings":{"total":0},"step":4,"cards":[{"rank":11,"suit":"diamonds"},{"rank":3,"suit":"hearts"},{"rank":14,"suit":"clubs"},{"rank":3,"suit":"spades"}],"open_card":[{"rank":5,"suit":"diamonds"}],"status":0}
                    ,{"balance":931,"winnings":{"total":0},"step":4,"cards":[{"rank":2,"suit":"clubs"},{"rank":3,"suit":"clubs"},{"rank":2,"suit":"spades"},{"rank":10,"suit":"diamonds"}],"open_card":[{"rank":8,"suit":"diamonds"}],"status":0}
                    ,{"balance":1117,"winnings":{"total":0},"step":1,"cards":[{"rank":5,"suit":"spades"},{"rank":8,"suit":"hearts"},{"rank":2,"suit":"hearts"},{"rank":10,"suit":"hearts"}],"open_card":[{"rank":7,"suit":"hearts"}],"status":0}
                ],
                resultBonusGame: [
                    {"balance":904,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[1,2,0],"position":15,"win":45,"winnings":[45,0,0],"remainder":1}],"total":45}}
                    ,{"balance":920,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[0,3,2],"position":21,"win":18,"winnings":[18,0,0],"remainder":1}],"total":20}}
                    ,{"balance":920,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[4,5,1],"position":5,"win":0,"winnings":[0,0,0],"remainder":1}],"total":20}}
                    ,{"balance":920,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[6,2,3],"position":8,"win":0,"winnings":[0,0,0],"remainder":1}],"total":20}}
                    ,{"balance":920,"bonus_game":{"fruitcockatail":{"remainder":0}},"winnings":{"bonuses":[{"symbols":[3,4,2],"position":0,"win":0,"winnings":[0,0,0],"exit":true,"last_exit":true,"remainder":0}],"total":20}}
                    ,{"balance":781,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[1,0,4],"position":6,"win":0,"winnings":[0,0,0],"remainder":1}],"total":2}}
                    ,{"balance":826,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[3,6,1],"position":18,"win":45,"winnings":[0,0,45],"remainder":1}],"total":47}}
                    ,{"balance":826,"bonus_game":{"fruitcockatail":{"remainder":1}},"winnings":{"bonuses":[{"symbols":[2,5,0],"position":19,"win":0,"winnings":[0,0,0],"remainder":1}],"total":47}}
                    ,{"balance":826,"bonus_game":{"fruitcockatail":{"remainder":0}},"winnings":{"bonuses":[{"symbols":[1,6,4],"position":0,"win":0,"winnings":[0,0,0],"exit":true,"last_exit":true,"remainder":0}],"total":47}}
                ]
            };
        g = function (c) {
            for (var d in A)if (A.hasOwnProperty(d))if (c.hasOwnProperty(d))switch (A[d]) {
                case "object":
                    if ("object" !== typeof c[d])return d;
                    break;
                case "int":
                    if ("number" !== typeof c[d])return d;
                    c[d] = parseInt(c[d]);
                    break;
                case "float":
                    if ("number" !== typeof c[d])return d;
                    break;
                case "boolean":
                    if ("boolean" !== typeof c[d])return d;
                    break;
                case "function":
                    if ("function" !== typeof c[d])return d
            } else {
                if (!w.hasOwnProperty(d))return d;
                c[d] = w[d]
            }
            return c
        }(g);
        if ("string" === typeof g)return !0 === l && console.log("GslotWrapper: Constructor failed. Bad option " + g), !1;
        var p = g.lines, q = g.reils, k = g.RT, d = g.LT, e = g.w, f = g.h, m = g.pdy, I = g.pdx, ba = g.borderRadius, N = g.linesMarginX, y = g.strokeWidth, u = g.startVelocity, z = g.startSpinsDelayFrames, D = g.outerSpeed, ra = g.spinnerDumping, ca = g.inertionDistance, da =
            g.shadowScreenOpacity, ea = g.returnSpeed, J = g.returnVelocity, Ua = g.stopSpinsDefault, Va = g.winLineAnimation, Wa = g.winLinesRepeats, Y = g.gameName, ua = g.tiles, l = g.gameTitle, Xa = g.scatterSymbol, Ya = g.linesValues, Za = g.wildSymbol, $a = g.multiple, ab = g.denominationRule, E = g.spinnersCount, Z = g.spinnerLength, bb = g.isFreegameRestart, ga = g.BACKURL, ha = g.CASHURL, K = g.LANGUAGE, sa = g.SHOWPOPUP, Ea = g.POPUPTIMEOUT, Fa = g.POPUPTITLE, Ga = g.POPUPTEXT, ta = g.POPUPREPEATS, V = g.POPUPBTN1URL, fa = g.POPUPBTN1TEXT, W = g.POPUPBTN2URL, X = g.POPUPBTN2TEXT, Ha =
            g.AUTHORIZED, ia = g.IScroll, va = g.scrollWrapper, ja = g.pointerLeft, ka = g.pointerRight, la = g.betsOffsetTop, Ia, v, r, c, t = [], C, L, F = [], Ja = [], S, O, G = [], T = g.animate, ma = !1, wa, xa, Ka, La, ya, za, Aa, P, H, Ma, Ba, Na, Q, aa, Ca, Oa, Pa, na, oa, Qa, Ra, Sa, pa, Ta, R, U, Da, qa = {
            "Register Now": {ru: "\u0420\u0435\u0433\u0438\u0441\u0442\u0440\u0430\u0446\u0438\u044f"},
            "Free Spins! All prizes x3": {ru: "Free Spins! \u0412\u0441\u0435 \u0432\u044b\u0438\u0433\u0440\u044b\u0448\u0438 x3"},
            "Free Spins!<br/>All prizes x3": {ru: "Free Spins!<br/>\u0412\u0441\u0435 \u0432\u044b\u0438\u0433\u0440\u044b\u0448\u0438 x3"},
            "Additional Free Spins!": {ru: "\u0414\u043e\u043f\u043e\u043b\u043d\u0438\u0442\u0435\u043b\u044c\u043d\u044b\u0445 Free Spins!"}
        }, M = [{
            obj: "#rulesContWrapper img:eq(0)",
            ru: "assets_files/rule1Ru.png",
            attr: "src"
        }, {obj: "#rulesContWrapper img:eq(1)", ru: "assets_files/rule2Ru.jpg", attr: "src"}], n;
        c = {
            connectUrl: g.connectUrl,
            connectType: "gms",
            postDataInit: {data: '{"action": "init", "game": "' + Y + '", "custom_vars": ' + JSON.stringify(custom_vars) + "}"},
            gameName: Y,
            state: 0,
            freeSpins: 0,
            isload: !1,
            bet: 0,
            betValues: [1, 2, 3, 4,
                5, 10, 15, 20, 30, 40, 50, 100],
            linesValues: Ya,
            wlAnimLength: d,
            scatterSymbol: Xa,
            spinnersCount: E,
            spinnerLength: Z,
            wildSymbol: Za,
            winLineAnimFlag: 0,
            pressedButtons: 0,
            denominationBets: [],
            disablePng: !1,
            prevDenomination: 0,
            isShowTotalWin: !1,
            betsState: {},
            realBalance: 0,
            realWin: 0,
            settings: [0, 0, 0],
            turbo: !1,
            settingsInit: [!1, !1, !1],
            lineBetInit: !1,
            flagBegin: 0,
            sumCount: 0,
            freespinsPlayed: 0,
            lastCount: 8,
            multiple: $a,
            denominationRule: ab,
            paytableInsertSymbols: g.paytableInsertSymbols,
            gameTitle: l,
            needLH: !1,
            winContainerObj: $("#wininfoResult")
        };
        if ("object" === typeof g.translates)for (n in g.translates)g.translates.hasOwnProperty(n) && (qa[n] = g.translates[n]);
        Da = function () {
            var c;
            for (c = M.length; c--;)M[c].obj && M[c][K] && (M[c].attr ? $(M[c].obj).attr(M[c].attr, M[c][K]) : $(M[c].obj).html(M[c][K]));
            if (g.translateNow)for (c = g.translateNow.length; c--;)g.translateNow[c].obj && g.translateNow[c][K] && (g.translateNow[c].attr ? $(g.translateNow[c].obj).attr(g.translateNow[c].attr, g.translateNow[c][K]) : $(g.translateNow[c].obj).html(g.translateNow[c][K]))
        };
        Ta = function () {
            if (sa) {
                $("#registerPopup .popupTitle").text(Fa);
                $("#registerPopup .popupText").text(Ga);
                if ("" === V || "" === fa)V = W, fa = X, X = W = "";
                $("#goToRegister").html("<span></span>");
                $("#goToRegister span").text(fa);
                "" !== X ? ($("#registerPopup .smallPopup").append('<div class="grayBtn rightPopBtn" id="goToRegister2"><span></span></div>'), $("#goToRegister2 span").text(X)) : $("#goToRegister").removeClass("leftPopBtn").addClass("centerPopBtn")
            }
        };
        Ia = function () {
            $("#spinControl").on("touchstart", function (d) {
                $("#mainContainer").hasClass("betMode") || (8 == c.state || c.money < c.betValues[c.bet] *
                c.linesValues[c.lines] && !("freeSpins" == c.freeSpinStatus && 0 < c.freeSpins) ? c.realMoney < c.minAvailableBet && 0 == c.flagBegin && Sa() && $("#mainContainer").addClass("popupMode") && $("#freeWindow").hide() : (d.stopPropagation(), d.preventDefault(), c.spinTimeout && clearTimeout(c.spinTimeout), c.spinTimeout = setTimeout(function () {
                    1 < c.pressedButtons || 1 == c.flagBegin || 3 == c.state || ($("#spinControl").removeClass("collect"), $("#maxBet,#setPlayBet,#setMaxBet").removeClass(), h.autoPlay(), c.spinAutoFlag = !0)
                }, 400)))
            });
            $("#spinControl").on("touchend",
                function (d) {
                    v() && ($("#mainContainer").hasClass("betMode") ? Aa() : 3 != c.state && !c.spinAutoFlag && 5 != c.state && (8 == c.state || c.money < c.betValues[c.bet] * c.linesValues[c.lines]) && 0 == c.flagBegin ? 8 != c.state && ($("#riskgameControl").hide(), h.isAllowSpin()) : (c.spinTimeout && clearTimeout(c.spinTimeout), $("#spinControl").removeClass("collect"), $("#maxBet,#setPlayBet,#setMaxBet").removeClass(), c.spinAutoFlag && 1 != c.flagBegin || (h.startSpin(), d.stopPropagation(), d.preventDefault()), c.spinAutoFlag = !1))
                });
            $("#backToLobby").on("touchend",
                function () {
                    console.log('backToLobby')
                    v() && (window.location = '/')
                });
            $(".cashIcon").on("touchend", function () {
                v() && (window.location != window.parent.location ? window.parent.location = ha : window.location = ha)
            });
            $("#riskgameControl").on("touchstart", function () {
                h.riskControlClick(this)
            });
            $("#maxBet").on("touchend", function () {
                v() && za()
            });
            $("#setPlayBet").on("touchend", function () {
                var d = $("body"), e = $("#mainContainer");
                !v() || e.hasClass("betMode") || d.hasClass("riskGameMode") ||
                d.hasClass("autoGameMode") || d.hasClass("spinMode") || d.hasClass("bonusGameMode") || d.hasClass("freeSpinMode") || (e.hasClass("settingsMode") && ($("#mainMenu").hide(), $("#mainContainer").removeClass("settingsMode"), !1 !== c.needLH && (1 == c.needLH ? $("#mainContainer").addClass("LH") : $("#mainContainer").removeClass("LH"), c.needLH = !1)), za())
            });
            $("#setMaxBet").on("touchend", function () {
                v() && (h.setMaxBet && h.setMaxBet(), $("#mobileBet,#betinfo").html(c.betValues[c.bet]), h.allowSpin(), h.isAllowSpin(), c.totalBet = c.betValues[c.bet] *
                    c.linesValues[c.lines])
            });
            $("#betsExit").on("touchend", function () {
                Aa()
            });
            $("#mainMenuBtn").on("touchend", function () {
                v() && Oa()
            });
            $("#backBtn").on("touchend", function () {
                v() && ($("#mainMenu").hide(), $("#mainContainer").removeClass("settingsMode"), !1 !== c.needLH && (1 == c.needLH ? $("#mainContainer").addClass("LH") : $("#mainContainer").removeClass("LH"), c.needLH = !1))
            });
            $("#spinControl,.paytableButt,#backToLobby,.cashIcon,.autoSpinButt,#betplusControl,#betminusControl,#linesplusControl,#setMaxBet,#linesminusControl,#mobileSoundButton,#maxBet,#setPlayBet,#goToHome,#betsExit,#mainMenuBtn,#backBtn,#yesBtn,#noBtn,#goToBank,#spinnerfield,.winNumbersLeft,.winNumbersRight,#reloadPage,#closeRegister,#goToRegister,#goToRegister2").on("touchstart",
                function () {
                    clearTimeout(U);
                    c.isSpinAnimation && Animate().stopAnimation("spinAnimation", !1);
                    $("#spinControl").removeAttr("style");
                    c.isSpinAnimation = !1;
                    c.pressedButtons++
                }).on("touchend", function () {
                clearTimeout(U);
                c.isSpinAnimation && Animate().stopAnimation("spinAnimation", !1);
                $("#spinControl").removeAttr("style");
                c.isSpinAnimation = !1
            });
            $("#riskgameControl").on("touchstart", function () {
                clearTimeout(U);
                c.isSpinAnimation && Animate().stopAnimation("spinAnimation", !1);
                $("#spinControl").removeAttr("style");
                c.isSpinAnimation = !1
            });
            $("#yesBtn").on("touchend", function () {
                v() && ($("#mobileSoundButton").addClass("off"),
                    h.setMute(!1),
                    $("#soundPopup").hide(),
                    $("#mainContainer").removeClass("popupMode"),
                    c.settings[0] = 1,
                    R(0),
                    wa(),
                    pa())
            });
            $("#noBtn").on("touchend", function () {
                v() && ($("#mobileSoundButton").removeClass("off"), h.setMute(!0), $("#soundPopup").hide(), $("#mainContainer").removeClass("popupMode"), c.settings[0] = 0, R(0), wa(), pa())
            });
            $("#goToBank").on("touchend", function () {
                v() && (window.location != window.parent.location ?
                    window.parent.location = ha : window.location = ha)
            });
            $("#goToHome").on("touchend", function () {
                v() && (window.location != window.parent.location ? window.parent.location = ga : window.location = ga)
            });
            $("#goToRegister").on("touchend", function () {
                v() && (window.location != window.parent.location ? window.parent.location = V : window.location = V)
            });
            $("#goToRegister2").on("touchend", function () {
                v() && (window.location != window.parent.location ? window.parent.location = W : window.location = W)
            });
            $("#closeRegister").on("touchend", function () {
                v() &&
                ($("#mainContainer").removeClass("popupMode"), $("#registerPopup").hide(), pa())
            });
            $("#spinnerfield,.winNumbersLeft,.winNumbersRight").on("touchend", function () {
                if (v() && 1 == c.state)return r.spin()
            });
            Q.on("touchstart", function () {
                Pa(this)
            })
        };
        Sa = function () {
            Ha || $("#goToBank").text(h.translate("Register Now"));
            $("#mainContainer").addClass("popupMode");
            $("#nomoneyPopup").show()
        };
        pa = function () {
            sa && 0 != ta && setTimeout(function () {
                $("#mainContainer").addClass("popupMode");
                $("#registerPopup").show();
                ta--
            }, 1E3 * Ea)
        };
        wa = function () {
            c.winLineAnimFlag = 1;
            setInterval(function () {
                var d = $("#spinCounter")[0], e = $("#mainContainer");
                0 != c.state || 0 == c.winLineAnimFlag || c.realMoney >= c.minAvailableBet && c.money < c.betValues[c.bet] * c.linesValues[c.lines] || e.hasClass("betMode") || e.hasClass("settingsMode") || $("#spinControl").hasClass("collect") ? (clearTimeout(U), c.isSpinAnimation && T.stopAnimation("spinAnimation", !1), $("#spinControl").removeAttr("style"), c.isSpinAnimation = !1) : c.isSpinAnimation || (U = setTimeout(function () {
                    c.isSpinAnimation = !0;
                    T.runAnimation({
                        object: d,
                        end: Animate().forever(),
                        className: "spinAnimation",
                        animations: [["opacity", "", "buttonPulse", ""]]
                    })
                }, 2500))
            }, 500)
        };
        Ka = function () {
            T.defineTraectory({
                buttonOpacity: [0, 1, 0, 500, .7, "float", 1E3, 1, "float"],
                buttonPulse: [0, 1, 0, 500, 0, "float", 1E3, 1, "float"]
            });
            Q = $(".menuPanel li");
            aa = $(".menuTab");
            Ca = 0;
            0 == Q.length && (Q = $(".menuPanel > div > div"))
        };
        v = function () {
            c.pressedButtons--;
            return 0 < c.pressedButtons ? !1 : !0
        };
        La = function (c, d) {
            if (c === d)return !0;
            if (null == c || null == d || c.length != d.length)return !1;
            for (var e = 0; e < c.length; ++e)if (c[e] !== d[e])return !1;
            return !0
        };
        xa = function (c) {
            var d;
            ma = c;
            L && L.setAnimateFlag && L.setAnimateFlag(c);
            C && C.setAnimateFlag && C.setAnimateFlag(c);
            if (F && F.length)for (d = F.length; d--;)F[d] && F[d].setAnimateFlag && F[d].setAnimateFlag(c)
        };
        ya = function () {
            if (!La(Ja, c.betValues)) {
                Ba();
                a = $("#linesRange .betSize").height();
                b = $("#linesRange .betSize").parent().parent().height();
                x = 100 * a / b;
                t[0] = la;
                for (n = 1; n < Math.max($("#linesRange .betSize").length, $("#betRange .betSize").length); n++)t[n] =
                    t[n - 1] - x;
                c.bet > c.betValues.length && (c.bet = c.betValues.length - 1);
                $("#betRange .betSize").parent().off("touchstart");
                $("#betRange .betSize").parent().off("touchmove");
                $("#betRange .betSize").parent().off("touchend");
                Ja = c.betValues.slice();
                L = new va({
                    page: "bets",
                    initPlace: {x: 0, y: t[c.betValues.length - 1 - c.bet]},
                    endPlace: {x: 0, y: t[c.betValues.length - 1 - c.bet]},
                    top: {min: t[c.betValues.length - 1], max: la},
                    orientation: "v",
                    parametr: "top",
                    obj: $("#betRange .betSize").parent(),
                    touchObj: $("#betRange .betSize").parent(),
                    settings: c.settings,
                    animateFlag: ma,
                    barrelSector: G,
                    offsetTop: t,
                    rollToPos: oa,
                    onSettingUpdate: R,
                    checkPosition: na
                });
                $("#betRange .betSize").parent().on("touchstart", L.touchStart);
                $("#betRange .betSize").parent().on("touchmove", L.touchMove);
                $("#betRange .betSize").parent().on("touchend", L.touchEnd);
                $("#betRange").css("top", t[c.betValues.length - 1 - c.bet] + "%");
                $("#betRange .betSize").removeClass("selected");
                $("#betRange :nth-child(" + (c.betValues.length - c.bet) + ")").addClass("selected")
            }
        };
        za = function () {
            var d,
                e;
            c.betsState = {bet: c.betValues[c.bet], lines: c.linesValues[c.lines], denomination: c.denomination};
            H(c.linesValues[c.lines]);
            P(c.betValues[c.bet]);
            if (!$("#spinControl").hasClass("active"))if (clearTimeout(U), $("#mainContainer").hasClass("betMode") && (h.setMaxBet && h.setMaxBet(), $("#mobileBet,#betinfo").html(c.betValues[c.bet])), c.prevDenomination = c.denomination, c.isShowTotalWin = $("#usualPanel").is(":visible"), $(".betWindow").show(), $("#nomoneyPopup").hide(), $("#usualPanel").hide(), $("#betModePanel").show(),
                    $("#mainContainer").removeClass("popupMode").addClass("betMode"), h.allowSpin(), h.onBetOpen(), c.lineBetInit)H(c.linesValues[c.lines]), P(c.betValues[c.bet]), h.showBet(c.betValues[c.bet] * c.linesValues[c.lines]); else {
                S = parseInt($("#betWrapper").height());
                O = parseInt($("#betWrapper").css("top"));
                G[0] = O;
                G[1] = O + .3 * S;
                G[2] = O + .31 * S;
                G[3] = O + .5 * S;
                G[4] = O + .69 * S;
                G[5] = O + .7 * S;
                G[6] = O + S;
                if (0 == t.length)for (d = $("#linesRange .betSize").height(), e = $("#linesRange .betSize").parent().parent().height(), d = 100 * d / e, t[0] = la, n = 1; n < Math.max($("#linesRange .betSize").length,
                    $("#betRange .betSize").length); n++)t[n] = t[n - 1] - d;
                $("#linesRange").css("top", t[c.linesValues.length - 1 - c.lines] + "%");
                $("#linesRange .betSize").removeClass("selected");
                $("#linesRange :nth-child(" + (c.linesValues.length - c.lines) + ")").addClass("selected");
                C = new va({
                    page: "bets",
                    initPlace: {x: 0, y: t[c.linesValues.length - 1 - c.lines]},
                    endPlace: {x: 0, y: t[c.linesValues.length - 1 - c.lines]},
                    top: {min: t[c.linesValues.length - 1], max: la},
                    orientation: "v",
                    parametr: "top",
                    obj: $("#linesRange .betSize").parent(),
                    touchObj: $("#linesRange .betSize").parent(),
                    settings: c.settings,
                    animateFlag: ma,
                    barrelSector: G,
                    offsetTop: t,
                    rollToPos: oa,
                    onSettingUpdate: R,
                    checkPosition: na
                });
                $("#linesRange .betSize").parent().on("touchstart", C.touchStart);
                $("#linesRange .betSize").parent().on("touchmove", C.touchMove);
                $("#linesRange .betSize").parent().on("touchend", C.touchEnd);
                ya();
                H(c.linesValues[c.lines]);
                P(c.betValues[c.bet]);
                c.lineBetInit = !0
            }
        };
        Aa = function () {
            c.pressedButtons--;
            0 < c.pressedButtons || h.betsExit()
        };
        Oa = function () {
            aa.hide();
            Q.removeClass("selected");
            $(Q[Ca]).addClass("selected");
            $(aa[Ca]).show();
            $("#mainMenu").show();
            $("#mainContainer").addClass("settingsMode");
            new ia(".menuTab.paytableTab", {
                fadeScrollbars: !0,
                freeScroll: !0,
                indicators: {
                    el: "#paytableScroller",
                    fade: !1,
                    interactive: !1,
                    listenY: !0,
                    shrink: !1,
                    speedRatioY: 0
                }
            });
            c.settingsInit[0] = !0
        };
        H = function (d) {
            $("#betRange div").addClass("disabled");
            for (n = 0; n < c.betValues.length; n++)d * c.betValues[n] <= c.money && $($("#betRange div")[c.betValues.length - 1 - n]).removeClass("disabled")
        };
        P = function (d) {
            $("#linesRange div").addClass("disabled");
            for (n = 0; n < c.linesValues.length; n++)d * c.linesValues[n] <= c.money && $($("#linesRange div")[c.linesValues.length - 1 - n]).removeClass("disabled")
        };
        Ma = function () {
            var d = "", e = 0;
            $("#linesRange .betSize").remove();
            for (n = c.linesValues.length - 1; 0 <= n; n--)e++, d += '<div class="betSize">' + c.linesValues[n] + "</div>";
            $("#linesRange").append(d)
        };
        Ba = function () {
            var d = "", e = 0;
            $("#betRange .betSize").remove();
            $("#betRange br").remove();
            for (n = c.betValues.length - 1; 0 <= n; n--)e++, d += '<div class="betSize">' + c.betValues[n] + "</div>";
            $("#betRange").append(d)
        };
        Na = function () {
            var d = "", e = 0, B = c.denominationRanges.length - 1 - c.denominationRanges.indexOf(c.denomination);
            $("#denominationRange .betSize").remove();
            for (n = c.denominationRanges.length - 1; 0 <= n; n--)e++, d += '<div class="betSize denomSize">' + c.denominationRanges[n] + "</div>";
            $("#denominationRange").append(d);
            $($("#denominationRange .betSize")[B]).addClass("selected");
            $("#denominationRange").children("div").on("touchstart", function () {
                var d = parseFloat($(this).text());
                B = c.denominationRanges.length -
                    1 - c.denominationRanges.indexOf(d);
                $(this).hasClass("disabled") || (h.setDenomination(c.denominationRanges.indexOf(d)), ya(), P(c.betValues[c.bet]), H(c.linesValues[c.lines]), h.showBet(c.betValues[c.bet] * c.linesValues[c.lines]), $("#mobileBet,#betinfo").html(c.betValues[c.bet]), $("#denominationRange .betSize").removeClass("selected"), $($("#denominationRange .betSize")[B]).addClass("selected"))
            })
        };
        Pa = function (d) {
            index = $(d).index();
            id = $(d).attr("id");
            $(Q).removeClass("selected");
            $(aa).hide();
            $(Q[index]).addClass("selected");
            $(aa[index]).show();
            if ("settsBtn" != id || c.settingsInit[index])"rulesBtn" == id ? (new ia(".menuTab.rulesTab", {
                fadeScrollbars: !0,
                freeScroll: !0,
                indicators: {el: "#rulesScroller", fade: !1, interactive: !1, listenY: !0, shrink: !1, speedRatioY: 0}
            }), c.settingsInit[index] = !0) : "bonusGameBtn" == id ? (bonusScroll = new ia(".menuTab.bonusTab", {
                fadeScrollbars: !0,
                freeScroll: !0,
                indicators: {el: "#bonusScroller", fade: !1, interactive: !1, listenY: !0, shrink: !1, speedRatioY: 0}
            }), c.settingsInit[index] = !0) : "paytableBtn" == id && new ia(".menuTab.paytableTab",
                {
                    fadeScrollbars: !0,
                    freeScroll: !0,
                    indicators: {
                        el: "#paytableScroller",
                        fade: !1,
                        interactive: !1,
                        listenY: !0,
                        shrink: !1,
                        speedRatioY: 0
                    }
                }); else {
                for (n = 0; n < $(".selectPointer").length; n++)1 == c.settings[n] ? $($(".selectPointer")[n]).css("left", ka + "%").addClass("on") : $($(".selectPointer")[n]).css("left", ja + "%").removeClass("on"), F[n] = new va({
                    page: "settings",
                    initPlace: {x: 1 == c.settings[n] ? ka : ja, y: 0},
                    endPlace: {x: 1 == c.settings[n] ? ka : ja, y: 0},
                    left: {min: ja, max: ka},
                    orientation: "h",
                    parametr: "left",
                    obj: $($(".selectPointer")[n]),
                    touchObj: $($(".selectPointer")[n]).parent(),
                    onClass: "on",
                    settings: c.settings,
                    animateFlag: ma,
                    barrelSector: G,
                    offsetTop: t,
                    rollToPos: oa,
                    onSettingUpdate: R,
                    checkPosition: na
                }), $($(".selectPointer")[n]).parent().on("touchstart", F[n].touchStart), $($(".selectPointer")[n]).parent().on("touchmove", F[n].touchMove), $($(".selectPointer")[n]).parent().on("touchend", F[n].touchEnd);
                c.settingsInit[index] = !0
            }
        };
        na = function (d, e, B) {
            var f = e.attr("id"), g = null;
            $.each(t, function () {
                if (null == g || Math.abs(this - d) < Math.abs(g - d))g =
                    parseFloat(this)
            });
            B ? (B = t.indexOf(g) + 1, $("#" + f + " .betSize").removeClass("selected"), $("#" + f + " :nth-child(" + B + ")").addClass("selected"), "betRange" == f ? (c.bet = c.betValues.length - B, $("#mobileBet").text(c.betValues[c.bet]), P(c.betValues[c.bet])) : (c.lines = c.linesValues.length - B, $("#mobileLines").text(c.linesValues[c.lines]), H(c.linesValues[c.lines]))) : (B = t.indexOf(g), h.showBet(c.betValues[c.bet] * c.linesValues[c.lines]), $("#mobileBet,#betinfo").html(c.betValues[c.bet]), e.css("top", t[B] + "%"))
        };
        oa = function (d,
                       e, B) {
            var f = B.attr("id");
            $("#" + f + " .betSize").removeClass("selected");
            $("#" + f + " :nth-child(" + (e + 1) + ")").addClass("selected");
            "betRange" == f ? (c.bet = c.betValues.length - e - 1, $("#mobileBet").text(c.betValues[c.bet]), P(c.betValues[c.bet])) : (c.lines = c.linesValues.length - e - 1, $("#mobileLines").text(c.linesValues[c.lines]), H(c.linesValues[c.lines]));
            h.showBet(c.betValues[c.bet] * c.linesValues[c.lines]);
            $("#mobileBet,#betinfo").html(c.betValues[c.bet]);
            T.defineTraectory({barrelRule: [0, t[d], 0, 228, t[e], "float"]});
            T.runAnimation({
                object: B[0],
                className: "barrel",
                animations: [["top", "", "barrelRule", "%"]],
                beginCallback: function () {
                    xa(!0)
                },
                endCallback: function () {
                    xa(!1)
                }
            })
        };
        Qa = function (c) {
            return (c = document.cookie.match(new RegExp("(?:^|; )" + c.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, "\\$1") + "=([^;]*)"))) ? decodeURIComponent(c[1]) : void 0
        };
        Ra = function (c, d, e) {
            var h, f, g;
            e = e || {};
            h = e.expires;
            "number" == typeof h && h && (f = new Date, f.setTime(f.getTime() + 1E3 * h), h = e.expires = f);
            h && h.toUTCString && (e.expires = h.toUTCString());
            d = encodeURIComponent(d);
            c = c + "=" + d;
            for (g in e)c += "; " + g, d = e[g], !0 !== d && (c += "=" + d);
            document.cookie = c
        };
        R = function (d, e, f, g) {
            g = g || "undefined" === typeof d && "undefined" === typeof e && "undefined" === typeof f;
            "undefined" === typeof d && (c.settings = Qa("slotSettings"), c.settings = "string" !== typeof c.settings ? [0, 0, 0] : $.parseJSON(c.settings));
            f || Ra("slotSettings", JSON.stringify(c.settings));
            "undefined" === typeof d && (e = !0, d = 0);
            f = c.settings[d];
            switch (d) {
                case 0:
                    h.setMute(!f);
                    break;
                case 1:
                    g ? (f ? $("#mainContainer").addClass("LH") : $("#mainContainer").removeClass("LH"),
                        c.needLH = !1) : c.needLH = f ? 1 : 0;
                    break;
                case 2:
                    h.setTurbo(!!f)
            }
            e && c.settings.length > d + 1 && R(d + 1, !0, !0, g)
        };
        return h = {
            GSLOTRESULT: function (d) {
                var e = c.freeSpins ? c.freeSpins : 0, f, g;
                h.convertDenomination(d);
                c.moneyDiff = d.balance - c.money;
                h.updateBalance(d.balance, c.realData.balance);
                c.lastSpecSym = 0;
                c.bonusCount = 0;
                c.scatterCount = 0;
                c.freeSpinStatus = d.freeSpinStatus;
                c.freeSpins = d.freeSpins;
                c.result = d;
                h.updateWin(d.win, c.realData.win);
                c.freespinsBonus = !1;
                if ("gms" == c.connectType) {
                    c.result.winLines = [];
                    if (null != c.result.winnings) {
                        h.updateWin(c.result.winnings.total,
                            c.realData.winnings.total);
                        c.result.win = c.result.winnings.total;
                        c.result.winnings.free_spins && c.result.winnings.free_spins.hasOwnProperty("all_winning") ? h.updateWin(c.result.winnings.free_spins.all_winning, c.realData.winnings.free_spins.all_winning) : 0 < c.win_sum && (c.result.status = "chance");
                        c.winLinesLen = 0;
                        if (c.result.winnings.lines && (c.winLinesLen += c.result.winnings.lines.length, 0 < c.winLinesLen))for (f = 0; f < c.winLinesLen; f++) {
                            c.result.winLines[f] = {};
                            c.result.winLines[f].winSymbol = -1;
                            c.result.winLines[f].cash =
                                d.winnings.lines[f].winning;
                            c.result.winLines[f].line = d.winnings.lines[f].line + 1;
                            c.result.winLines[f].layout = [];
                            for (g = E; g--;)c.result.winLines[f].layout.push(0);
                            for (g = 0; g < c.result.winnings.lines[f].symbols.length; g++)c.result.winLines[f].layout[c.result.winnings.lines[f].symbols[g][0]] = c.result.winnings.lines[f].symbols[g][1] + 1;
                            for (g = 0; g < E; g++)if (0 != c.result.winLines[f].layout[g] && c.result.symbols[g][c.result.winLines[f].layout[g] - 1] + 1 != c.wildSymbol || !c.result.winLines[f].layout[g + 1] && 0 > c.result.winLines[f].winSymbol)c.result.winLines[f].winSymbol =
                                c.result.symbols[g][c.result.winLines[f].layout[g] - 1] + 1
                        }
                        if (c.result.winnings.scatters) {
                            c.winLinesLen += c.result.winnings.scatters.length;
                            if (0 < c.result.winnings.scatters.length)for (c.result.winLinesSC = [], f = 0; f < c.result.winnings.scatters.length; f++)for (c.result.winLinesSC[f] = {}, c.result.winLinesSC[f].winSymbol = c.scatterSymbol, c.result.winLinesSC[f].cash = d.winnings.scatters[f].winning, c.result.winLinesSC[f].line = 0, c.result.winLinesSC[f].layout = [0, 0, 0, 0, 0], c.result.winnings.scatters[f].symbols || (c.result.winnings.scatters[f] =
                                c.result.winnings.scatters[f]["0"]), g = 0; g < c.result.winnings.scatters[f].symbols.length; g++)c.result.winLinesSC[f].layout[c.result.winnings.scatters[f].symbols[g][0]] = c.result.winnings.scatters[f].symbols[g][1] + 1;
                            for (f = 0; f < c.result.winLinesSC.length; f++)c.result.winLines.push(c.result.winLinesSC[f])
                        }
                    } else c.winLinesLen = 0;
                    c.result.shiftReels = [];
                    for (f = 0; f < E; f++)for (c.result.shiftReels[f] = [], g = 0; g < Z + 2; g++)c.result.shiftReels[f][g] = 0 === g || g == Z + 1 ? Math.floor(5 * Math.random()) + 1 : c.result.symbols[f][g - 1] + 1;
                    null != c.result.winnings && c.result.winnings.free_spins ? c.result.winnings.free_spins && (c.result.freeSpins = c.freeSpins = c.result.winnings.free_spins.count, c.result.freeSpinStatus = c.freeSpinStatus = "freeSpins", e - 1 != c.freeSpins && (c.freeSpinsCount = 0 == e ? c.freeSpins : c.freeSpins - e + 1)) : (c.result.freeSpins = c.freeSpins = 0, c.result.freeSpinStatus = c.freeSpinStatus = "none")
                }
                h.updateBalance(d.balance, c.realData.balance);
                c.exp += d.exp;
                for (f = 0; f < c.result.winLines.length; f++)for (g = c.result.winLines[f].count = 0; g < E; g++)0 !=
                c.result.winLines[f].layout[g] && c.result.winLines[f].count++;
                h.processResult(d, c.result);
                r.setResult(c.result)
            }, slotogame: c, convertDenomination: function (d, e) {
                var f;
                "undefined" === typeof e && (e = c.denominationRule, c.realData = this.clone(d));
                if ("object" === typeof d && "length" in d)for (f = d.length; f--;)if ("object" === typeof d[f] && d[f])this.convertDenomination(d[f], e); else switch (e) {
                    case "float":
                        d[f] = (parseFloat(d[f]) / c.denomination).toFixed(3);
                        break;
                    case "int":
                        d[f] = parseInt((parseFloat(d[f]) / c.denomination).toFixed(3))
                } else if ("object" === typeof d && "object" === typeof e)for (f in e)if (e.hasOwnProperty(f) && d.hasOwnProperty(f))if ("object" === typeof d[f] && d[f])this.convertDenomination(d[f], e[f]); else switch (e[f]) {
                    case "float":
                        d[f] = (parseFloat(d[f]) / c.denomination).toFixed(3);
                        break;
                    case "int":
                        d[f] = parseInt((parseFloat(d[f]) / c.denomination).toFixed(3))
                }
            }, setDenomination: function (d) {
                c.denominationRanges.length <= d || (c.denomination = c.denominationRanges[d], $("#visibleDenomination").text(c.denomination), c.betValues = c.denominationBets[d], c.money =
                    parseInt((c.realMoney / c.denomination).toFixed(2)), this.showBet(c.betValues[c.bet] * c.linesValues[c.lines]), this.showBalance(0), P(c.betValues[c.bet]), H(c.linesValues[c.lines]))
            }, clone: function (c) {
                if (null == c || "object" != typeof c)return c;
                var d = new c.constructor, e;
                for (e in c)d[e] = this.clone(c[e]);
                return d
            }, reloadPage: function () {
                $("#usualPanel").hide();
                $("#connectionPopup").show();
                $("#mainContainer").addClass("popupMode");
                $("#reloadPage").on("touchend", function () {
                    c.pressedButtons--;
                    0 < c.pressedButtons ||
                    location.reload()
                })
            }, translate: function (c) {
                return qa.hasOwnProperty(c) && qa[c].hasOwnProperty(K) ? qa[c][K] : c
            }, checkBet: H, setMaxBet: function () {
                if ((0 === c.state || 6 == c.state || 8 == c.state) && "0" == c.freeSpins) {
                    for (c.bet = 0; !(c.bet >= c.betValues.length - 1 || c.money < c.betValues[c.bet + 1] * c.linesValues[c.lines]);)c.bet++;
                    h.showBet(c.betValues[c.bet] * c.linesValues[c.lines]);
                    $("#linesRange .betSize").removeClass("selected");
                    $("#linesRange :nth-child(" + (c.linesValues.length - c.lines) + ")").addClass("selected");
                    $("#linesRange").css("top",
                        t[c.linesValues.length - 1 - c.lines] + "%");
                    $("#betRange .betSize").removeClass("selected");
                    $("#betRange :nth-child(" + (c.betValues.length - c.bet) + ")").addClass("selected");
                    $("#betRange").css("top", t[c.betValues.length - 1 - c.bet] + "%");
                    C && C.hasOwnProperty("endPlace") && C.endPlace.hasOwnProperty("y") && (C.endPlace.y = C.initPlace.y = t[c.linesValues.length - 1 - c.lines], L.endPlace.y = L.initPlace.y = t[c.betValues.length - 1 - c.bet]);
                    H(c.linesValues[c.lines])
                }
            }, isAllowSpin: function () {
                c.realMoney >= c.minAvailableBet && c.money <
                c.betValues[c.bet] * c.linesValues[c.lines] && ($("#spinControl").addClass("graySpin"), $("#maxBet,#setPlayBet,#setMaxBet").addClass("highlight"), T.runAnimation({
                    object: $("#maxBet,#setPlayBet")[0],
                    end: Animate().forever(),
                    className: "betHighlight",
                    animations: [["opacity", "", "buttonOpacity", ""]]
                }), $("#lowBalanceMess").removeAttr("style"), this.hideWinPanel(!0), this.showBalance(0))
            }, allowSpin: function () {
                T.stopAnimation("betHighlight", !1);
                $("#spinControl").removeClass("graySpin");
                $("#maxBet,#setPlayBet").removeClass("highlight");
                $("#lowBalanceMess").hide()
            }, updateBalance: function (d, e) {
                c.money = parseInt(d);
                c.realMoney = parseFloat(e)
            }, updateWin: function (d, e) {
                c.win_sum = parseInt(d);
                c.realWin = parseFloat(e)
            }, showWin: function (d) {
                "undefined" !== typeof d ? ($("#wininfoResult").html(d), $("#winMoney").html((d * c.denomination).toFixed(2).replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1,")), 0 < d ? (1E6 <= d ? $("#usualPanel").removeClass("fsSize2").addClass("fsSize3") : 1E3 <= d ? $("#usualPanel").removeClass("fsSize3").addClass("fsSize2") : $("#usualPanel").removeClass("fsSize2 fsSize3"),
                    $(".winCenter").show(), this.showWinPanel()) : (clearInterval(c.winTickAnim), $("#usualPanel").removeClass("fsSize2 fsSize3"), $(".winCenter").hide())) : ($("#wininfoResult").html(c.win_sum), $("#winMoney").html(c.realWin.toFixed(2).replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1,")), 0 < c.win_sum ? ($(".winCenter").show(), 1E6 <= c.win_sum ? $("#usualPanel").removeClass("fsSize2").addClass("fsSize3") : 1E3 <= c.win_sum ? $("#usualPanel").removeClass("fsSize3").addClass("fsSize2") : $("#usualPanel").removeClass("fsSize2 fsSize3"),
                    this.showWinPanel()) : (clearInterval(c.winTickAnim), $("#usualPanel").removeClass("fsSize2 fsSize3"), $(".winCenter").hide()))
            }, showTotalWin: function (c) {
                $("#totalWinInfo").html(c);
                $(".winRight").show();
                this.showWinPanel()
            }, showFreespins: function (c, d) {
                $(".winLeft").show();
                $("#playedFreespins").text(c);
                $("#totalFreespins").text(d);
                this.showWinPanel()
            }, hideWinPanel: function (d) {
                $("#winMoney").text(0);
                $("#playedFreespins,#totalFreespins,#wininfoResult,#totalWinInfo").text(0);
                d || c.turbo || $("#mainContainer").hasClass("settingsMode") ?
                    ($("#usualPanel,.winLeft,.winCenter,.winRight").hide(), $("#usualPanel").removeClass("fsSize2 fsSize3")) : $("#usualPanel").fadeOut(250, function () {
                    $(".winLeft,.winCenter,.winRight").hide();
                    $("#usualPanel").removeClass("fsSize2 fsSize3")
                })
            }, showWinPanel: function () {
                $("#lowBalanceMess").is(":visible") || $("#riskModePanel").is(":visible") || (c.turbo || $("#mainContainer").hasClass("settingsMode") || $("#mainContainer").hasClass("popupMode") ? !$("#usualPanel").is(":visible") && $("#usualPanel").removeAttr("style") :
                !$("#usualPanel").is(":visible") && $("#usualPanel").fadeIn(250, function () {
                    !$("#mainContainer").hasClass("popupMode") && $("#usualPanel").removeAttr("style")
                }))
            }, showBet: function (d) {
                var e = (d + "").replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1 ");
                d = (d * c.denomination).toFixed(2);
                $("#betinfoResult,#panelTotalBet").html(e);
                $("#betMoney").html(d.replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1,"));
                $("#panelRealBet").html(d.replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1 "))
            }, showBalance: function (d) {
                $("#mainBalance").html((c.money +
                d + "").replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1 "));
                $("#cashMoney").html((c.realMoney + d * c.denomination).toFixed(2).replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g, "$1,"))
            }, setTurbo: function (d) {
                c.turbo = d;
                r.setTurbo(d, c.disablePng);
                d ? $("#mainContainer").addClass("turboMode") : $("#mainContainer").removeClass("turboMode")
            }, noMoney: function () {
                2 == c.state && c.realMoney >= c.minAvailableBet || (c.state = 8, $("#slotBody").removeClass().addClass("noMoneyMode"), c.lines = c.linesValues.length - 1, c.bet = 0, c.totalBet = c.linesValues[c.lines] *
                    c.betValues[c.bet], $("#mobileBet,#betinfo").html(c.betValues[c.bet]), $("#mobileLines,#linesinfo").html(c.linesValues[c.lines]), this.showBet(c.totalBet), r && r.stopWinLines(), this.resetLines())
            }, onLoad: function () {
                var d, e, f = [], g;
                e = r.rtiles;
                $(".scatterWildLine img");
                for (d = 0; 5 > d; d++)e[d][3].container.hide();
                Ma();
                Ba();
                Na();
                this.winLineShow();
                $("#spinControl").removeClass();
                this.isAllowSpin();
                $(".gameTitle").text(c.gameTitle);
                $("#main")[0].style.overflow = "visible";
                $("#spinnerfield")[0].style.overflow = "visible";
                for (d = Z; d--;) {
                    f[d] = [];
                    for (e = E; e--;)f[d].push("<i></i>");
                    f[d] = f[d].join("")
                }
                f = f.join("<br/>");
                for (d = 1; d < p.length; d++)for ($(".linesPaytabBlock ul").append('<li><span class="linePaytabNum">' + d + '</span><div class="linePaytaGraph" id="payLine' + d + '">' + f + "</div></li>"), g = $("#payLine" + d + " i"), e = E; e--;)g[(p[d][e] - 1) * E + e].setAttribute("class", "act");
                if (c.paytableInsertSymbols)for (d = 0; d < c.paytableInsertSymbols.length; d++)!1 !== c.paytableInsertSymbols[d] && $(".scatterWildLine img")[d].setAttribute("src", ua[c.paytableInsertSymbols[d]].img);
                this.onLoadHandler()
            }, onTotalBet: function () {
                if ((0 === c.state || 6 == c.state) && "0" == c.freeSpins)for (r.stopWinLines(), this.onBetChange(), this.resetLines(), n = 1; n <= c.linesValues[c.lines]; n++)this.winLineShow(n)
            }, paytableFunction: function () {
                var d = c.multiple, e = $(".symbolValBlock ul"), f, g, h, k, l, m, n = c.betValues[c.bet], q = c.linesValues[c.lines], r;
                for (f in d)if (d.hasOwnProperty(f)) {
                    r = 0 < $("#symbol" + f).length;
                    k = [];
                    l = d[f].values;
                    m = d[f]["double"];
                    line = d[f].hasOwnProperty("scatter") && d[f].scatter ? q : 1;
                    h = l.length;
                    for (g =
                             0; g < h; g++)k.push('<div class="symbolCount">' + (E - g) + '</div><i></i><div class="symbolPay">' + l[g] * n * line + "</div>" + (m ? '<div class="symbolPayDouble">' + l[g] * n * 2 * line + "</div>" : ""));
                    g = "";
                    r || (g += '<li><img src="' + ua[f].img + '"/></div><span class="symbolInfo" id="symbol' + f + '">');
                    g += k.join("<br/>");
                    r ? $("#symbol" + f).html(g) : (g += "</span></li>", e.append(g))
                }
                $(".win_number").text(c.betValues[c.bet]).addClass("notActive").text("");
                for (f = 1; f <= c.linesValues[c.lines]; f++)$("#win_number" + f + ", #win_number" + (10 * Math.ceil((p.length -
                        1) / 10) + f)).removeClass("notActive").text(n)
            }, onBetChange: function () {
                c.money < c.totalBet ? ($("#mobileBet,#betinfo").html(c.betValues[c.bet]), this.showBet(c.totalBet)) : (c.nextTotalBetLine = c.linesValues[c.lines + 1] * c.betValues[c.bet], c.nextTotalBet = c.linesValues[c.lines + 1] * c.betValues[c.bet], $("#linesplusControl").removeClass("disabled"), $("#linesminusControl").removeClass("disabled"), $("#betminusControl").removeClass("disabled"), $("#betplusControl").removeClass("disabled"), (c.lines == c.linesValues.length -
                1 || c.linesValues[c.lines + 1] * c.betValues[c.bet] > c.money) && $("#linesplusControl").addClass("disabled"), 0 === c.lines && $("#linesminusControl").addClass("disabled"), 0 === c.bet && $("#betminusControl").addClass("disabled"), (c.bet == c.betValues.length - 1 || c.linesValues[c.lines] * c.betValues[c.bet + 1] > c.money) && $("#betplusControl").addClass("disabled"), c.totalBet = c.linesValues[c.lines] * c.betValues[c.bet], $("#mobileBet,#betinfo").html(c.betValues[c.bet]), $("#mobileLines,#linesinfo").html(c.linesValues[c.lines]), this.showBet(c.totalBet),
                    this.paytableFunction(), this.balanceCheck())
            }, balanceCheck: function (d) {
                if ("freeSpins" != c.freeSpinStatus || "0" == c.freeSpins) {
                    if (c.money < c.totalBet)if (c.money < c.minBet)this.noMoney(), d && this.winLineShow(); else this.onBetChange();
                    8 == c.state && c.money >= c.minBet && (c.state = 0, $("#slotBody").removeClass())
                }
            }, connect: function () {
                var d = this;
                // $.ajax({
                //     type: "POST",
                //     url: c.connectUrl,
                //     dataType: "json",
                //     data: c.postDataInit,
                //     timeout: 15E3,
                //     success: function (e) {
                //         var f;
                //         c.denomination = e.denomination;
                //         $("#visibleDenomination").text(c.denomination);
                //         c.denominationRanges = [];
                //         d.convertDenomination(e);
                //         c.doubleLimit = e.limits && e.limits["double"] && e.limits["double"].max_multiplier ? e.limits["double"].max_multiplier : !1;
                //         e.ranges && e.ranges.bet && (c.betValues = e.ranges.bet);
                //         e.ranges && e.ranges.denomination && (c.denominationRanges = e.ranges.denomination);
                //         if (e.ranges && e.ranges.bet_extended)for (f = c.denominationRanges.length; f--;)e.ranges.bet_extended.hasOwnProperty(c.denominationRanges[f]) && (c.denominationBets[f] = e.ranges.bet_extended[c.denominationRanges[f]], c.denomination ==
                //         c.denominationRanges[f] && (c.betValues = e.ranges.bet_extended[c.denominationRanges[f]]));
                //         c.minAvailableBet = c.betValues[0] * c.linesValues[0];
                //         for (f = c.denominationBets.length; f--;)c.denominationBets[f][0] * c.linesValues[0] * c.denominationRanges[f] < c.minAvailableBet && (c.minAvailableBet = c.denominationBets[f][0] * c.linesValues[0] * c.denominationRanges[f]);
                //         d.updateBalance(e.balance, c.realData.balance);
                //         c.lines = c.linesValues.length - 1;
                //         c.totalBet = c.linesValues[c.lines] * c.betValues[c.bet];
                //         c.minBet = c.linesValues[0] *
                //             c.betValues[0];
                //         c.isload ? (Da(), d.onLoad(), d.paytableFunction(), d.onBetChange(), c.isload = !1) : c.isload = !0;
                //         d.showBalance(0);
                //         d.balanceCheck(!0);
                //         d.onConnect(e)
                //     },
                //     error: function () {
                //         d.updateBalance(0, 0);
                //         c.lines = c.linesValues.length - 1;
                //         c.totalBet = c.linesValues[c.lines] * c.betValues[c.bet];
                //         c.minBet = c.linesValues[0] * c.betValues[0];
                //         d.showBalance(0);
                //         d.balanceCheck();
                //         d.onBetChange();
                //         c.denomination = 1;
                //         $("#visibleDenomination").text(c.denomination);
                //         d.reloadPage && d.reloadPage()
                //     }
                // });
                resp = {"balance":1000,"ranges":{"bet_extended":{"0.01":[1,2,3,4,5,6,7,8,9,10,15,20,25,50,100,200],"0.1":[1,2,3,4,5,6,7,8,9,10,15,20,25,50,100,200],"1":[1,2,3,4,5,6,7,8,9,10,15,20,25,50,100,200],"10":[1,2,3,4,5,6,7,8,9,10,15,20,25,50,100]},"bet":[1,2,3,4,5,6,7,8,9,10,15,20,25,50,100,200],"denomination":[0.01,0.1,1,10]},"lines":9,"bet":1,"limits":{"double":[]},"symbols":[[1,5,6],[6,8,2],[6,5,7],[0,8,5],[7,6,8]],"freespin_count":null,"freespin_winnings":null,"denomination":1};
                function suc(e) {
                    var f;
                    c.denomination = e.denomination;
                    $("#visibleDenomination").text(c.denomination);
                    c.denominationRanges = [];
                    d.convertDenomination(e);
                    c.doubleLimit = e.limits && e.limits["double"] && e.limits["double"].max_multiplier ? e.limits["double"].max_multiplier : !1;
                    e.ranges && e.ranges.bet && (c.betValues = e.ranges.bet);
                    e.ranges && e.ranges.denomination && (c.denominationRanges = e.ranges.denomination);
                    if (e.ranges && e.ranges.bet_extended)for (f = c.denominationRanges.length; f--;)e.ranges.bet_extended.hasOwnProperty(c.denominationRanges[f]) && (c.denominationBets[f] = e.ranges.bet_extended[c.denominationRanges[f]], c.denomination ==
                    c.denominationRanges[f] && (c.betValues = e.ranges.bet_extended[c.denominationRanges[f]]));
                    c.minAvailableBet = c.betValues[0] * c.linesValues[0];
                    for (f = c.denominationBets.length; f--;)c.denominationBets[f][0] * c.linesValues[0] * c.denominationRanges[f] < c.minAvailableBet && (c.minAvailableBet = c.denominationBets[f][0] * c.linesValues[0] * c.denominationRanges[f]);
                    d.updateBalance(e.balance, c.realData.balance);
                    c.lines = c.linesValues.length - 1;
                    c.totalBet = c.linesValues[c.lines] * c.betValues[c.bet];
                    c.minBet = c.linesValues[0] *
                        c.betValues[0];
                    c.isload ? (Da(), d.onLoad(), d.paytableFunction(), d.onBetChange(), c.isload = !1) : c.isload = !0;
                    d.showBalance(0);
                    d.balanceCheck(!0);
                    d.onConnect(e)
                }

                suc(resp)
                Ka()
            }, simpleWinAnim: function (d) {
                0 != d &&
                (c.winTickAnim && clearInterval(c.winTickAnim), "undefined" === typeof d && (d = c.win_sum), 0 < d - parseInt(c.winContainerObj.html(), 10) && (c.winTick = Math.ceil((d - parseInt(c.winContainerObj.html(), 10)) / (c.wlAnimLength / 50)), c.winTickAnim = setInterval(function () {
                    parseInt(c.winContainerObj.html(), 10) + c.winTick <= d && (0 == c.state || 8 == c.state || 6 == c.state) ? c.winContainerObj.html(parseInt(c.winContainerObj.html(), 10) + c.winTick) : (c.winContainerObj.html(d), clearInterval(c.winTickAnim))
                }, 50), $("#winMoney").html(c.realWin.toFixed(2).replace(/(\d)(?=(\d\d\d)+([^\d]|$))/g,
                    "$1,"))), 0 < d && $(".winCenter").show() && this.showWinPanel(), 1E6 <= d ? $("#usualPanel").removeClass("fsSize2").addClass("fsSize3") : 1E3 <= d ? $("#usualPanel").removeClass("fsSize3").addClass("fsSize2") : $("#usualPanel").removeClass("fsSize2 fsSize3"))
            }, winLineShow: function (d) {
                var e = 10 * Math.ceil((p.length - 1) / 10);
                if (d)r && r.showLine(d), $("#win_number" + d + ",#win_number" + (d + e)).addClass("border"); else for (d = 0; d < c.linesValues[c.linesValues.length - 1]; d++)$("#win_number" + (d + 1) + ",#win_number" + (d + e + 1)).addClass("border"),
                r && r.showLine(d + 1)
            }, resetLines: function () {
                var d = 10 * Math.ceil((p.length - 1) / 10), e;
                for (e = 1; e <= c.linesValues[c.linesValues.length - 1]; e++)$("#win_number" + e + ",#win_number" + (e + d)).removeClass("border"), r && r.hideLine(e)
            }, riskControlClick: function (d) {
                $("#spinControl").hasClass("active") || (0 === c.state || 2 == c.state || 6 == c.state) && 0 < c.win_sum && h.riskGameInit()
            }, riskGameInit: function () {
                var d = this;
                c.state = 3;
                c.hasOwnProperty("disableWinFlag") || (c.winLineAnimFlag = 1);
                $("#slotBody").removeClass().addClass("riskGameMode");
                $(".spinPanel").css("z-index", "9999");
                $("#spinControl").removeClass("collect").addClass("disabled");
                $("#maxBet,#setPlayBet,#setMaxBet").removeClass();
                $("#riskgameControl").css("display", "none");
                this.onRiskGameInit();
                // $.ajax({
                //     type: "POST",
                //     url: c.connectUrl,
                //     dataType: "json",
                //     data: {data: '{"action": "get_double", "game": "' + Y + '", "custom_vars": ' + JSON.stringify(custom_vars) + "}"},
                //     timeout: 15E3,
                //     success: function (c) {
                //         d.convertDenomination(c);
                //         d.hideWinPanel(!0);
                //         d.onRiskInitPost(c)
                //     },
                //     error: function () {
                //         d.reloadPage &&
                //         d.reloadPage()
                //     }
                // })
                var resultGetDouble = w.resultGetDouble[w.random(w.resultGetDouble.length - 1)]
                d.convertDenomination(resultGetDouble);
                d.hideWinPanel(!0);
                d.onRiskInitPost(resultGetDouble)
            }, riskClick: function (d) {
                if (3 == c.state) {
                    var e = this;
                    // $.ajax({
                    //     type: "POST",
                    //     url: c.connectUrl,
                    //     dataType: "json",
                    //     data: {data: '{"action": "set_double", "game": "' + Y + '", "choice": ' + d + ', "custom_vars": ' + JSON.stringify(custom_vars) + "}"},
                    //     timeout: 15E3,
                    //     success: function (f) {
                    //         var g = c.win_sum;
                    //         e.convertDenomination(f);
                    //         e.updateBalance(f.balance, c.realData.balance);
                    //         e.updateWin(f.winnings.total, c.realData.winnings.total);
                    //         e.onRiskSelectPost(f, g, d)
                    //     },
                    //     error: function () {
                    //         e.reloadPage && e.reloadPage()
                    //     }
                    // })
                    var resultSetDouble = w.resultSetDouble[w.random(w.resultSetDouble.length - 1)]
                    var g = c.win_sum;
                    e.convertDenomination(resultSetDouble);
                    e.updateBalance(resultSetDouble.balance, c.realData.balance);
                    e.updateWin(resultSetDouble.winnings.total, c.realData.winnings.total);
                    e.onRiskSelectPost(resultSetDouble, g, d)
                }
            }, stopRisk: function () {
                !1 !==
                this.onRiskStop(c.win_sum) && (this.allowSpin(), $("#slotBody").removeClass(), $(".spinPanel").css("z-index", "1000"), this.balanceCheck(), this.isAllowSpin(), 0 < c.win_sum ? (this.simpleWinAnim(c.win_sum, "risk"), $("#slotBody").removeClass(), c.state = 0) : (this.showWin(0), c.money < c.minBet ? (c.state = 8, $("#slotBody").removeClass().addClass("noMoneyMode")) : (c.state = 0, $("#slotBody").removeClass())), this.onBetChange(), this.showBalance(0))
            }, bonusClick: function (d, e) {
                if (4 == c.state) {
                    var f = this;
                    // $.ajax({
                    //     type: "POST",
                    //     url: c.connectUrl,
                    //     dataType: "json",
                    //     data: {data: '{"action": "bonus_game", "game": "' + Y + '", "bonus_game": "' + e + '", "choice": ' + d + ', "custom_vars": ' + JSON.stringify(custom_vars) + "}"},
                    //     timeout: 15E3,
                    //     success: function (e) {
                    //         var g = c.win_sum;
                    //         f.convertDenomination(e);
                    //         f.updateBalance(e.balance, c.realData.balance);
                    //         f.updateWin(e.winnings.total, c.realData.winnings.total);
                    //         f.onBonusSelectPost(e, g, d)
                    //     },
                    //     error: function () {
                    //         f.reloadPage && f.reloadPage()
                    //     }
                    // })
                    var resultBonusGame = w.resultBonusGame[w.random(w.resultBonusGame.length - 1)]
                    var g = c.win_sum;
                    f.convertDenomination(resultBonusGame);
                    f.updateBalance(resultBonusGame.balance, c.realData.balance);
                    f.updateWin(resultBonusGame.winnings.total, c.realData.winnings.total);
                    f.onBonusSelectPost(resultBonusGame, g, d)
                }
            }, endBonus: function () {
                $(".bonusGame").hide();
                c.result.status = "none";
                this.balanceCheck();
                this.simpleWinAnim(c.win_sum + c.winBeforeBonus);
                this.onBonusEnd()
            }, onStatus: {
                chance: function (c, d) {
                }, bonus: function (d, e) {
                    c.state = 4
                }, error: function (c, d) {
                }
            }, onWinLinesRepeats: function (d, e, f) {
                var g;
                c.winLineAnimFlag = 1;
                $(".win_number").removeClass("border");
                if ("none" != c.freeSpinStatus && 0 < c.freeSpins) {
                    g = $("#freeWindow");
                    if (1 == c.flagBegin)c.freeSpins > c.lastCount && !g.is(":visible") ? (c.lastCount = c.freeSpins, d = this.onMoreFreegames(c.freeSpinsCount), !1 !== d && setTimeout(function () {
                        g.hide();
                        f.spin()
                    }, d ? d : 2E3)) :
                        f.spin(), c.lastCount--; else if (c.flagBegin = 1, !g.is(":visible"))this.onFreegames(c.freeSpinsCount);
                    return !0
                }
                if ("0" == c.freeSpins && "freeSpins" == c.freeSpinStatus)return this.onEndFreegames(c.win_sum, c.sumCount), c.state = 0, c.sumCount = 0, this.onBetChange(), !0;
                if (2 == c.state && c.money >= c.totalBet)return f.spin(), !0;
                if (2 == c.state && c.realMoney >= c.minAvailableBet)return c.state = 0, $("#slotBody").removeClass(), this.isAllowSpin(), !0
            }, onSpinEnd: function (d, e, f) {
                e = f.rtiles;
                for (d = 0; 5 > d; d++)e[d][-1].container.hide();
                $("#main")[0].style.overflow =
                    "visible";
                $("#spinnerfield")[0].style.overflow = "visible";
                "0" == c.freeSpins && "freeSpins" == c.freeSpinStatus && (c.flagBegin = 0, c.freespinsPlayed = -1, c.spinSoundStop = 0, d = $("#spinControl"), d.addClass("disabled"), h.showTotalWin(c.win_sum));
                if (1 == c.state || 8 == c.state)c.state = 0;
                "0" == c.freeSpins && 0 === c.state && ("freeSpins" !== c.freeSpinStatus && $("#slotBody").removeClass(), 1 > c.win_sum && c.money < c.minBet && this.noMoney(), 1 > c.win_sum && this.isAllowSpin());
                this.balanceCheck();
                c.spinState = 0;
                0 != c.sumCount && c.freespinsPlayed++;
                "none" != c.freeSpinStatus && 0 < c.freeSpins && (c.state = 5, 1 == c.flagBegin ? c.freeSpins > c.lastCount && (bb ? (c.sumCount = c.freeSpinsCount, c.freespinsPlayed = 1) : c.sumCount += c.freeSpinsCount) : 0 == c.flagBegin && (c.spinSoundStop = 1, this.simpleWinAnim(c.win_sum), c.lastCount = c.freeSpins, c.freespinsPlayed = 1, $("#slotBody").removeClass().addClass("riskGameMode"), $("#spinControl").addClass("disabled"), c.sumCount += c.freeSpins));
                this.onSpinEndHandler()
            }, onWin: function (d, e, f) {
                e = c.betValues[c.bet];
                f = c.linesValues[c.lines];
                this.showWin(d);
                "0" == c.freeSpins && "freeSpins" != c.freeSpinStatus && 4 != c.state && (this.onBetChange(), (!1 === c.doubleLimit || c.doubleLimit * e * f >= c.win_sum) && $("#riskgameControl").removeAttr("style"))
            }, onSpinBegin: function (d) {
                var e, f = d.rtiles;
                $("#main")[0].style.overflow = "hidden";
                $("#spinnerfield")[0].style.overflow = "hidden";
                for (e = f.length; e--;)f[e][-1] ? f[e][-1].container.show() : f[e][3].container.show();
                $("img.gcontainer").show();
                $(".win_number").removeClass("border");
                0 == c.flagBegin && this.hideWinPanel();
                d.setWinlineDelay(c.wlAnimLength);
                c.currentLineTime = c.wlAnimLength;
                c.spinState = 1;
                c.linesAnimState = 0;
                c.winLinesCycles = 0;
                c.winLineAnimFlag = 0;
                c.disablePng = !1;
                2 == c.state ? $("#slotBody").removeClass().addClass("autoGameMode") : 1 == c.state && $("#slotBody").removeClass().addClass("spinMode");
                this.showWin(0);
                this.onSpinBeginHandler(d);
                "0" != c.freeSpins && (this.showFreespins(c.freespinsPlayed, c.sumCount), this.showTotalWin(c.win_sum));
                clearInterval(c.winTickAnim);
                $("#riskgameControl").hide();
                "0" == c.freeSpins && (this.showWin(0), $("#freeWindow").hide());
                0 === c.state && (c.state = 1);
                "0" == c.freeSpins && this.showBalance(c.betValues[c.bet] * c.linesValues[c.lines] * -1)
            }, callServer: function () {
                var d = this;
                this.balanceCheck();
                // $.ajax({
                //     type: "POST",
                //     url: c.connectUrl,
                //     dataType: "json",
                //     data: {data: '{"action": "spin", "game": "' + c.gameName + '", "bet": "' + c.betValues[c.bet] * c.denomination + '", "lines": "' + c.linesValues[c.lines] + '", "denomination": "' + c.denomination + '", "custom_vars": ' + JSON.stringify(custom_vars) + "}"},
                //     timeout: 15E3,
                //     success: function (c) {
                //         h.GSLOTRESULT(c)
                //     },
                //     error: function () {
                //         d.reloadPage &&
                //         d.reloadPage()
                //     }
                // })

                h.GSLOTRESULT(w.resultSpin[w.random(w.resultSpin.length - 1)])
            }, onResourcesLoaded: function () {
                var g = this;
                r = new GSlot({
                    id: "main",
                    RT: k,
                    LT: d,
                    w: e,
                    h: f,
                    pdy: m,
                    pdx: I,
                    borderRadius: ba,
                    reils: q,
                    lines: p,
                    spinnersCount: E,
                    spinnerLength: Z,
                    linesMarginX: N,
                    strokeWidth: y,
                    winLineAnimation: Va,
                    shadowScreenOpacity: da,
                    insert: document.getElementById("spinnerfield"),
                    startVelocity: u,
                    startSpinsDelayFrames: z,
                    outerSpeed: D,
                    spinnerDumping: ra,
                    inertionDistance: ca,
                    returnSpeed: ea,
                    returnVelocity: J,
                    stopSpinsDefault: Ua,
                    tiles: ua,
                    winLineRepeatDelay: 200,
                    winLinesRepeats: Wa,
                    onWinLinesRepeats: function (c,
                                                 d) {
                        return g.onWinLinesRepeats(c, d, r)
                    },
                    winLineContrast: 0,
                    onWinLineShow: function (d, e, f, h, k) {
                        -1 !== e && -1 !== f && ($(".win_number").removeClass("border"), 0 != d && $("#win_number" + d + ",#win_number" + (10 * Math.ceil((p.length - 1) / 10) + d)).addClass("border"));
                        d = g.onWinLineShow(d, e, f, k, r, c.winLineAnimFlag, c.turbo);
                        "number" === typeof d && d != c.currentLineTime && (c.currentLineTime = d, r.setWinlineDelay(d))
                    },
                    onFreeSpins: function (c) {
                    },
                    onSpinEnd: function (c, d) {
                        return g.onSpinEnd(c, d, r)
                    },
                    onWin: function (c, d) {
                        return g.onWin(c, d, r)
                    },
                    onSpinBegin: function () {
                        return g.onSpinBegin(r)
                    },
                    callServer: function () {
                        return g.callServer()
                    },
                    onStatus: g.onStatus,
                    onSpinnerStop: function (c, d) {
                        return g.onSpinnerStop(c, d, r)
                    }
                });
                c.Slot = r;
                R();
                // $("#soundPopup").show();
                // $("#mainContainer").addClass("popupMode");

                v() && ($("#mobileSoundButton").removeClass("off"), h.setMute(!0), $("#soundPopup").hide(), $("#mainContainer").removeClass("popupMode"), c.settings[0] = 0, R(0), wa(), pa())

                c.isload ? (Da(), this.onLoad(), this.paytableFunction(), this.onBetChange(), c.isload = !1) : c.isload = !0;
                Ta();
                Ia()
            }, startSpin: function () {
                var d = $("#spinControl");
                if (!$("#slotBody").hasClass("freeSpinMode") && 0 < c.freeSpins && !d.hasClass("disabled"))1 != c.state &&
                ($("#freeWindow").hide(), $("#spinControl").removeClass("startAuto"), $("#slotBody").removeClass().addClass("freeSpinMode")), r.spin(); else if (!(d.hasClass("disabled") || 0 < c.freeSpins)) {
                    if (1 == c.state)return r.spin();
                    2 == c.state ? this.autoPlay() : 3 == c.state ? this.stopRisk() : c.money >= c.totalBet ? "0" != c.freeSpins || 0 !== c.state && 6 != c.state || (c.state = 1, r.spin()) : c.money < c.totalBet && this.noMoney()
                }
            }, autoPlay: function () {
                if (!($("#spinControl").hasClass("disabled") || 0 < c.freeSpins) && c.money >= c.totalBet)if ((0 === c.state ||
                    6 == c.state) && "0" == c.freeSpins)c.state = 2, r.spin(); else if (2 == c.state && (c.state = 0, $("#slotBody").removeClass(), 1 == c.spinState))return r.spin()
            }, betsExit: function () {
                var d;
                $(".betWindow").hide();
                c.prevDenomination !== c.denomination && $("#riskgameControl").hide();
                $("#betModePanel").hide();
                c.isShowTotalWin && $("#usualPanel").removeAttr("style");
                $("#mainContainer").removeClass("betMode");
                h.balanceCheck();
                h.paytableFunction();
                c.totalBet = c.linesValues[c.lines] * c.betValues[c.bet];
                if (h.onBetChange && h.resetLines &&
                    h.winLineShow)for (r.stopWinLines(), h.onBetChange(), h.resetLines(), d = 1; d <= c.linesValues[c.lines]; d++)h.winLineShow(d); else h.onTotalBet();
                h.isAllowSpin();
                h.onBetsExit(c.betsState.bet === c.betValues[c.bet], c.betsState.lines === c.linesValues[c.lines], c.betsState.denomination === c.denomination)
            }, processResult: function (c, d) {
            }, onMoreFreegames: function (c) {
            }, onFreegames: function (c) {
            }, onEndFreegames: function (c, d) {
            }, onLoadHandler: function () {
            }, onSpinBeginHandler: function () {
            }, onWinLineShow: function (c, d, e, f, g, h,
                                        k) {
                return 1E3
            }, onSpinnerStop: function (c, d, e) {
            }, onRiskGameInit: function () {
            }, onRiskInitPost: function (c) {
            }, onRiskStop: function (c) {
            }, onRiskSelectPost: function (c, d, e) {
            }, onBonusSelectPost: function (c, d, e) {
            }, onBonusEnd: function () {
            }, onSpinEndHandler: function () {
            }, setMute: function (c) {
            }, onConnect: function (c) {
            }, onBetsExit: function (c, d, e) {
            }, onBetOpen: function () {
            }
        }
    }
}();